/* gitg-remote-notification.c generated by valac 0.56.3, the Vala compiler
 * generated from gitg-remote-notification.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2012 - Ignacio Casal Quinteiro
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include "libgitg-ext.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include <glib/gi18n-lib.h>

#define GITG_REMOTE_NOTIFICATION_version VERSION
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GITG_TYPE_REMOTE_NOTIFICATION (gitg_remote_notification_get_type ())
#define GITG_REMOTE_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_REMOTE_NOTIFICATION, GitgRemoteNotification))
#define GITG_REMOTE_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_REMOTE_NOTIFICATION, GitgRemoteNotificationClass))
#define GITG_IS_REMOTE_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_REMOTE_NOTIFICATION))
#define GITG_IS_REMOTE_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_REMOTE_NOTIFICATION))
#define GITG_REMOTE_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_REMOTE_NOTIFICATION, GitgRemoteNotificationClass))

typedef struct _GitgRemoteNotification GitgRemoteNotification;
typedef struct _GitgRemoteNotificationClass GitgRemoteNotificationClass;
typedef struct _GitgRemoteNotificationPrivate GitgRemoteNotificationPrivate;
enum  {
	GITG_REMOTE_NOTIFICATION_0_PROPERTY,
	GITG_REMOTE_NOTIFICATION_WIDGET_PROPERTY,
	GITG_REMOTE_NOTIFICATION_TEXT_PROPERTY,
	GITG_REMOTE_NOTIFICATION_REMOTE_STATE_PROPERTY,
	GITG_REMOTE_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* gitg_remote_notification_properties[GITG_REMOTE_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block69Data Block69Data;
typedef struct _Block70Data Block70Data;
typedef struct _Block71Data Block71Data;
typedef struct _Block72Data Block72Data;
typedef struct _Block73Data Block73Data;
enum  {
	GITG_REMOTE_NOTIFICATION_CANCEL_SIGNAL,
	GITG_REMOTE_NOTIFICATION_NUM_SIGNALS
};
static guint gitg_remote_notification_signals[GITG_REMOTE_NOTIFICATION_NUM_SIGNALS] = {0};

struct _GitgRemoteNotification {
	GitgProgressBin parent_instance;
	GitgRemoteNotificationPrivate * priv;
};

struct _GitgRemoteNotificationClass {
	GitgProgressBinClass parent_class;
};

struct _GitgRemoteNotificationPrivate {
	GitgRemote* d_remote;
	GtkImage* d_image_icon;
	GtkLabel* d_label_text;
	GtkButton* d_button_cancel;
	gboolean d_finished;
	gchar* d_text;
};

struct _Block69Data {
	int _ref_count_;
	GitgRemoteNotification* self;
	gchar* text;
};

struct _Block70Data {
	int _ref_count_;
	GitgRemoteNotification* self;
	gchar* text;
};

struct _Block71Data {
	int _ref_count_;
	GitgRemoteNotification* self;
	gboolean auto_close;
};

struct _Block72Data {
	int _ref_count_;
	GitgRemoteNotification* self;
	gchar* value;
};

struct _Block73Data {
	int _ref_count_;
	GitgRemoteNotification* self;
	GitgRemoteState value;
};

static gint GitgRemoteNotification_private_offset;
static gpointer gitg_remote_notification_parent_class = NULL;
static GitgExtNotificationIface * gitg_remote_notification_gitg_ext_notification_parent_iface = NULL;

VALA_EXTERN GType gitg_remote_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GitgRemoteNotification, g_object_unref)
VALA_EXTERN GitgRemoteNotification* gitg_remote_notification_new (GitgRemote* remote);
VALA_EXTERN GitgRemoteNotification* gitg_remote_notification_construct (GType object_type,
                                                            GitgRemote* remote);
VALA_EXTERN void gitg_remote_notification_success (GitgRemoteNotification* self,
                                       const gchar* text);
static Block69Data* block69_data_ref (Block69Data* _data69_);
static void block69_data_unref (void * _userdata_);
static gboolean __lambda104_ (Block69Data* _data69_);
VALA_EXTERN void gitg_remote_notification_set_text (GitgRemoteNotification* self,
                                        const gchar* value);
static void gitg_remote_notification_finish (GitgRemoteNotification* self,
                                      gboolean auto_close);
static gboolean ___lambda104__gsource_func (gpointer self);
VALA_EXTERN void gitg_remote_notification_error (GitgRemoteNotification* self,
                                     const gchar* text);
static Block70Data* block70_data_ref (Block70Data* _data70_);
static void block70_data_unref (void * _userdata_);
static gboolean __lambda107_ (Block70Data* _data70_);
static gboolean ___lambda107__gsource_func (gpointer self);
static Block71Data* block71_data_ref (Block71Data* _data71_);
static void block71_data_unref (void * _userdata_);
static gboolean __lambda106_ (Block71Data* _data71_);
static gboolean ___lambda106__gsource_func (gpointer self);
static void gitg_remote_notification_on_button_cancel_clicked (GitgRemoteNotification* self);
static void _gitg_remote_notification_on_button_cancel_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
VALA_EXTERN const gchar* gitg_remote_notification_get_text (GitgRemoteNotification* self);
static Block72Data* block72_data_ref (Block72Data* _data72_);
static void block72_data_unref (void * _userdata_);
static gboolean _gitg_remote_notification_text___lambda105_ (Block72Data* _data72_);
static gboolean __gitg_remote_notification_text___lambda105__gsource_func (gpointer self);
VALA_EXTERN void gitg_remote_notification_set_remote_state (GitgRemoteNotification* self,
                                                GitgRemoteState value);
static Block73Data* block73_data_ref (Block73Data* _data73_);
static void block73_data_unref (void * _userdata_);
static gboolean _gitg_remote_notification_remote_state___lambda108_ (Block73Data* _data73_);
static gboolean __gitg_remote_notification_remote_state___lambda108__gsource_func (gpointer self);
static void gitg_remote_notification_finalize (GObject * obj);
static GType gitg_remote_notification_get_type_once (void);
static void _vala_gitg_remote_notification_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_gitg_remote_notification_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
gitg_remote_notification_get_instance_private (GitgRemoteNotification* self)
{
	return G_STRUCT_MEMBER_P (self, GitgRemoteNotification_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "../gitg/gitg-remote-notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 189 "gitg-remote-notification.c"
}

GitgRemoteNotification*
gitg_remote_notification_construct (GType object_type,
                                    GitgRemote* remote)
{
	GitgRemoteNotification * self = NULL;
	GitgRemote* _tmp0_;
	GitgRemote* _tmp1_;
	GitgRemote* _tmp2_;
#line 46 "../gitg/gitg-remote-notification.vala"
	g_return_val_if_fail (remote != NULL, NULL);
#line 46 "../gitg/gitg-remote-notification.vala"
	self = (GitgRemoteNotification*) gitg_progress_bin_construct (object_type);
#line 48 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = _g_object_ref0 (remote);
#line 48 "../gitg/gitg-remote-notification.vala"
	_g_object_unref0 (self->priv->d_remote);
#line 48 "../gitg/gitg-remote-notification.vala"
	self->priv->d_remote = _tmp0_;
#line 50 "../gitg/gitg-remote-notification.vala"
	_tmp1_ = self->priv->d_remote;
#line 50 "../gitg/gitg-remote-notification.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp1_, "state", (GObject*) self, "remote_state", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 51 "../gitg/gitg-remote-notification.vala"
	_tmp2_ = self->priv->d_remote;
#line 51 "../gitg/gitg-remote-notification.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp2_, "transfer-progress", (GObject*) self, "fraction", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 46 "../gitg/gitg-remote-notification.vala"
	return self;
#line 220 "gitg-remote-notification.c"
}

GitgRemoteNotification*
gitg_remote_notification_new (GitgRemote* remote)
{
#line 46 "../gitg/gitg-remote-notification.vala"
	return gitg_remote_notification_construct (GITG_TYPE_REMOTE_NOTIFICATION, remote);
#line 228 "gitg-remote-notification.c"
}

static Block69Data*
block69_data_ref (Block69Data* _data69_)
{
#line 59 "../gitg/gitg-remote-notification.vala"
	g_atomic_int_inc (&_data69_->_ref_count_);
#line 59 "../gitg/gitg-remote-notification.vala"
	return _data69_;
#line 238 "gitg-remote-notification.c"
}

static void
block69_data_unref (void * _userdata_)
{
	Block69Data* _data69_;
	_data69_ = (Block69Data*) _userdata_;
#line 59 "../gitg/gitg-remote-notification.vala"
	if (g_atomic_int_dec_and_test (&_data69_->_ref_count_)) {
#line 248 "gitg-remote-notification.c"
		GitgRemoteNotification* self;
#line 59 "../gitg/gitg-remote-notification.vala"
		self = _data69_->self;
#line 59 "../gitg/gitg-remote-notification.vala"
		_g_free0 (_data69_->text);
#line 59 "../gitg/gitg-remote-notification.vala"
		_g_object_unref0 (self);
#line 59 "../gitg/gitg-remote-notification.vala"
		g_slice_free (Block69Data, _data69_);
#line 258 "gitg-remote-notification.c"
	}
}

static gboolean
__lambda104_ (Block69Data* _data69_)
{
	GitgRemoteNotification* self;
	GtkImage* _tmp0_;
	GtkStyleContext* _tmp1_;
	gboolean result;
#line 61 "../gitg/gitg-remote-notification.vala"
	self = _data69_->self;
#line 62 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = self->priv->d_image_icon;
#line 62 "../gitg/gitg-remote-notification.vala"
	g_object_set (_tmp0_, "icon-name", "emblem-ok-symbolic", NULL);
#line 63 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_set_text (self, _data69_->text);
#line 65 "../gitg/gitg-remote-notification.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 65 "../gitg/gitg-remote-notification.vala"
	gtk_style_context_add_class (_tmp1_, "success");
#line 67 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_finish (self, TRUE);
#line 69 "../gitg/gitg-remote-notification.vala"
	result = FALSE;
#line 69 "../gitg/gitg-remote-notification.vala"
	return result;
#line 287 "gitg-remote-notification.c"
}

static gboolean
___lambda104__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda104_ (self);
#line 61 "../gitg/gitg-remote-notification.vala"
	return result;
#line 297 "gitg-remote-notification.c"
}

void
gitg_remote_notification_success (GitgRemoteNotification* self,
                                  const gchar* text)
{
	Block69Data* _data69_;
	gchar* _tmp0_;
#line 59 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (self != NULL);
#line 59 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (text != NULL);
#line 59 "../gitg/gitg-remote-notification.vala"
	_data69_ = g_slice_new0 (Block69Data);
#line 59 "../gitg/gitg-remote-notification.vala"
	_data69_->_ref_count_ = 1;
#line 59 "../gitg/gitg-remote-notification.vala"
	_data69_->self = g_object_ref (self);
#line 59 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = g_strdup (text);
#line 59 "../gitg/gitg-remote-notification.vala"
	_g_free0 (_data69_->text);
#line 59 "../gitg/gitg-remote-notification.vala"
	_data69_->text = _tmp0_;
#line 61 "../gitg/gitg-remote-notification.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda104__gsource_func, block69_data_ref (_data69_), block69_data_unref);
#line 59 "../gitg/gitg-remote-notification.vala"
	block69_data_unref (_data69_);
#line 59 "../gitg/gitg-remote-notification.vala"
	_data69_ = NULL;
#line 328 "gitg-remote-notification.c"
}

static Block70Data*
block70_data_ref (Block70Data* _data70_)
{
#line 73 "../gitg/gitg-remote-notification.vala"
	g_atomic_int_inc (&_data70_->_ref_count_);
#line 73 "../gitg/gitg-remote-notification.vala"
	return _data70_;
#line 338 "gitg-remote-notification.c"
}

static void
block70_data_unref (void * _userdata_)
{
	Block70Data* _data70_;
	_data70_ = (Block70Data*) _userdata_;
#line 73 "../gitg/gitg-remote-notification.vala"
	if (g_atomic_int_dec_and_test (&_data70_->_ref_count_)) {
#line 348 "gitg-remote-notification.c"
		GitgRemoteNotification* self;
#line 73 "../gitg/gitg-remote-notification.vala"
		self = _data70_->self;
#line 73 "../gitg/gitg-remote-notification.vala"
		_g_free0 (_data70_->text);
#line 73 "../gitg/gitg-remote-notification.vala"
		_g_object_unref0 (self);
#line 73 "../gitg/gitg-remote-notification.vala"
		g_slice_free (Block70Data, _data70_);
#line 358 "gitg-remote-notification.c"
	}
}

static gboolean
__lambda107_ (Block70Data* _data70_)
{
	GitgRemoteNotification* self;
	GtkImage* _tmp0_;
	GtkStyleContext* _tmp1_;
	gboolean result;
#line 75 "../gitg/gitg-remote-notification.vala"
	self = _data70_->self;
#line 76 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = self->priv->d_image_icon;
#line 76 "../gitg/gitg-remote-notification.vala"
	g_object_set (_tmp0_, "icon-name", "network-error-symbolic", NULL);
#line 77 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_set_text (self, _data70_->text);
#line 79 "../gitg/gitg-remote-notification.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 79 "../gitg/gitg-remote-notification.vala"
	gtk_style_context_add_class (_tmp1_, "error");
#line 80 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_finish (self, FALSE);
#line 82 "../gitg/gitg-remote-notification.vala"
	result = FALSE;
#line 82 "../gitg/gitg-remote-notification.vala"
	return result;
#line 387 "gitg-remote-notification.c"
}

static gboolean
___lambda107__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda107_ (self);
#line 75 "../gitg/gitg-remote-notification.vala"
	return result;
#line 397 "gitg-remote-notification.c"
}

void
gitg_remote_notification_error (GitgRemoteNotification* self,
                                const gchar* text)
{
	Block70Data* _data70_;
	gchar* _tmp0_;
#line 73 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (self != NULL);
#line 73 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (text != NULL);
#line 73 "../gitg/gitg-remote-notification.vala"
	_data70_ = g_slice_new0 (Block70Data);
#line 73 "../gitg/gitg-remote-notification.vala"
	_data70_->_ref_count_ = 1;
#line 73 "../gitg/gitg-remote-notification.vala"
	_data70_->self = g_object_ref (self);
#line 73 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = g_strdup (text);
#line 73 "../gitg/gitg-remote-notification.vala"
	_g_free0 (_data70_->text);
#line 73 "../gitg/gitg-remote-notification.vala"
	_data70_->text = _tmp0_;
#line 75 "../gitg/gitg-remote-notification.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda107__gsource_func, block70_data_ref (_data70_), block70_data_unref);
#line 73 "../gitg/gitg-remote-notification.vala"
	block70_data_unref (_data70_);
#line 73 "../gitg/gitg-remote-notification.vala"
	_data70_ = NULL;
#line 428 "gitg-remote-notification.c"
}

static Block71Data*
block71_data_ref (Block71Data* _data71_)
{
#line 86 "../gitg/gitg-remote-notification.vala"
	g_atomic_int_inc (&_data71_->_ref_count_);
#line 86 "../gitg/gitg-remote-notification.vala"
	return _data71_;
#line 438 "gitg-remote-notification.c"
}

static void
block71_data_unref (void * _userdata_)
{
	Block71Data* _data71_;
	_data71_ = (Block71Data*) _userdata_;
#line 86 "../gitg/gitg-remote-notification.vala"
	if (g_atomic_int_dec_and_test (&_data71_->_ref_count_)) {
#line 448 "gitg-remote-notification.c"
		GitgRemoteNotification* self;
#line 86 "../gitg/gitg-remote-notification.vala"
		self = _data71_->self;
#line 86 "../gitg/gitg-remote-notification.vala"
		_g_object_unref0 (self);
#line 86 "../gitg/gitg-remote-notification.vala"
		g_slice_free (Block71Data, _data71_);
#line 456 "gitg-remote-notification.c"
	}
}

static gboolean
__lambda106_ (Block71Data* _data71_)
{
	GitgRemoteNotification* self;
	GtkButton* _tmp0_;
	gboolean result;
#line 88 "../gitg/gitg-remote-notification.vala"
	self = _data71_->self;
#line 89 "../gitg/gitg-remote-notification.vala"
	self->priv->d_finished = TRUE;
#line 90 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = self->priv->d_button_cancel;
#line 90 "../gitg/gitg-remote-notification.vala"
	gtk_button_set_label (_tmp0_, _ ("Close"));
#line 92 "../gitg/gitg-remote-notification.vala"
	if (_data71_->auto_close) {
#line 94 "../gitg/gitg-remote-notification.vala"
		g_signal_emit_by_name ((GitgExtNotification*) self, "close", (guint) 3000);
#line 478 "gitg-remote-notification.c"
	}
#line 97 "../gitg/gitg-remote-notification.vala"
	result = FALSE;
#line 97 "../gitg/gitg-remote-notification.vala"
	return result;
#line 484 "gitg-remote-notification.c"
}

static gboolean
___lambda106__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda106_ (self);
#line 88 "../gitg/gitg-remote-notification.vala"
	return result;
#line 494 "gitg-remote-notification.c"
}

static void
gitg_remote_notification_finish (GitgRemoteNotification* self,
                                 gboolean auto_close)
{
	Block71Data* _data71_;
#line 86 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (self != NULL);
#line 86 "../gitg/gitg-remote-notification.vala"
	_data71_ = g_slice_new0 (Block71Data);
#line 86 "../gitg/gitg-remote-notification.vala"
	_data71_->_ref_count_ = 1;
#line 86 "../gitg/gitg-remote-notification.vala"
	_data71_->self = g_object_ref (self);
#line 86 "../gitg/gitg-remote-notification.vala"
	_data71_->auto_close = auto_close;
#line 88 "../gitg/gitg-remote-notification.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda106__gsource_func, block71_data_ref (_data71_), block71_data_unref);
#line 86 "../gitg/gitg-remote-notification.vala"
	block71_data_unref (_data71_);
#line 86 "../gitg/gitg-remote-notification.vala"
	_data71_ = NULL;
#line 518 "gitg-remote-notification.c"
}

static void
gitg_remote_notification_on_button_cancel_clicked (GitgRemoteNotification* self)
{
#line 141 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (self != NULL);
#line 143 "../gitg/gitg-remote-notification.vala"
	if (self->priv->d_finished) {
#line 145 "../gitg/gitg-remote-notification.vala"
		g_signal_emit_by_name ((GitgExtNotification*) self, "close", (guint) 0);
#line 530 "gitg-remote-notification.c"
	} else {
#line 149 "../gitg/gitg-remote-notification.vala"
		g_signal_emit (self, gitg_remote_notification_signals[GITG_REMOTE_NOTIFICATION_CANCEL_SIGNAL], 0);
#line 534 "gitg-remote-notification.c"
	}
}

static void
_gitg_remote_notification_on_button_cancel_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
#line 24 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_on_button_cancel_clicked ((GitgRemoteNotification*) self);
#line 544 "gitg-remote-notification.c"
}

static GtkWidget*
gitg_remote_notification_real_get_widget (GitgExtNotification* base)
{
	GtkWidget* result;
	GitgRemoteNotification* self;
	GtkWidget* _tmp0_;
#line 56 "../gitg/gitg-remote-notification.vala"
	self = (GitgRemoteNotification*) base;
#line 56 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = _g_object_ref0 ((GtkWidget*) self);
#line 56 "../gitg/gitg-remote-notification.vala"
	result = _tmp0_;
#line 56 "../gitg/gitg-remote-notification.vala"
	return result;
#line 561 "gitg-remote-notification.c"
}

const gchar*
gitg_remote_notification_get_text (GitgRemoteNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 103 "../gitg/gitg-remote-notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = self->priv->d_text;
#line 105 "../gitg/gitg-remote-notification.vala"
	result = _tmp0_;
#line 105 "../gitg/gitg-remote-notification.vala"
	return result;
#line 577 "gitg-remote-notification.c"
}

static Block72Data*
block72_data_ref (Block72Data* _data72_)
{
#line 108 "../gitg/gitg-remote-notification.vala"
	g_atomic_int_inc (&_data72_->_ref_count_);
#line 108 "../gitg/gitg-remote-notification.vala"
	return _data72_;
#line 587 "gitg-remote-notification.c"
}

static void
block72_data_unref (void * _userdata_)
{
	Block72Data* _data72_;
	_data72_ = (Block72Data*) _userdata_;
#line 108 "../gitg/gitg-remote-notification.vala"
	if (g_atomic_int_dec_and_test (&_data72_->_ref_count_)) {
#line 597 "gitg-remote-notification.c"
		GitgRemoteNotification* self;
#line 108 "../gitg/gitg-remote-notification.vala"
		self = _data72_->self;
#line 108 "../gitg/gitg-remote-notification.vala"
		_g_free0 (_data72_->value);
#line 108 "../gitg/gitg-remote-notification.vala"
		_g_object_unref0 (self);
#line 108 "../gitg/gitg-remote-notification.vala"
		g_slice_free (Block72Data, _data72_);
#line 607 "gitg-remote-notification.c"
	}
}

static gboolean
_gitg_remote_notification_text___lambda105_ (Block72Data* _data72_)
{
	GitgRemoteNotification* self;
	GtkLabel* _tmp0_;
	gboolean result;
#line 110 "../gitg/gitg-remote-notification.vala"
	self = _data72_->self;
#line 111 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = self->priv->d_label_text;
#line 111 "../gitg/gitg-remote-notification.vala"
	gtk_label_set_label (_tmp0_, _data72_->value);
#line 112 "../gitg/gitg-remote-notification.vala"
	result = FALSE;
#line 112 "../gitg/gitg-remote-notification.vala"
	return result;
#line 627 "gitg-remote-notification.c"
}

static gboolean
__gitg_remote_notification_text___lambda105__gsource_func (gpointer self)
{
	gboolean result;
	result = _gitg_remote_notification_text___lambda105_ (self);
#line 110 "../gitg/gitg-remote-notification.vala"
	return result;
#line 637 "gitg-remote-notification.c"
}

void
gitg_remote_notification_set_text (GitgRemoteNotification* self,
                                   const gchar* value)
{
	Block72Data* _data72_;
	gchar* _tmp0_;
#line 108 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (self != NULL);
#line 108 "../gitg/gitg-remote-notification.vala"
	_data72_ = g_slice_new0 (Block72Data);
#line 108 "../gitg/gitg-remote-notification.vala"
	_data72_->_ref_count_ = 1;
#line 108 "../gitg/gitg-remote-notification.vala"
	_data72_->self = g_object_ref (self);
#line 108 "../gitg/gitg-remote-notification.vala"
	_tmp0_ = g_strdup (value);
#line 108 "../gitg/gitg-remote-notification.vala"
	_g_free0 (_data72_->value);
#line 108 "../gitg/gitg-remote-notification.vala"
	_data72_->value = _tmp0_;
#line 110 "../gitg/gitg-remote-notification.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __gitg_remote_notification_text___lambda105__gsource_func, block72_data_ref (_data72_), block72_data_unref);
#line 108 "../gitg/gitg-remote-notification.vala"
	block72_data_unref (_data72_);
#line 108 "../gitg/gitg-remote-notification.vala"
	_data72_ = NULL;
#line 108 "../gitg/gitg-remote-notification.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_remote_notification_properties[GITG_REMOTE_NOTIFICATION_TEXT_PROPERTY]);
#line 668 "gitg-remote-notification.c"
}

static Block73Data*
block73_data_ref (Block73Data* _data73_)
{
#line 119 "../gitg/gitg-remote-notification.vala"
	g_atomic_int_inc (&_data73_->_ref_count_);
#line 119 "../gitg/gitg-remote-notification.vala"
	return _data73_;
#line 678 "gitg-remote-notification.c"
}

static void
block73_data_unref (void * _userdata_)
{
	Block73Data* _data73_;
	_data73_ = (Block73Data*) _userdata_;
#line 119 "../gitg/gitg-remote-notification.vala"
	if (g_atomic_int_dec_and_test (&_data73_->_ref_count_)) {
#line 688 "gitg-remote-notification.c"
		GitgRemoteNotification* self;
#line 119 "../gitg/gitg-remote-notification.vala"
		self = _data73_->self;
#line 119 "../gitg/gitg-remote-notification.vala"
		_g_object_unref0 (self);
#line 119 "../gitg/gitg-remote-notification.vala"
		g_slice_free (Block73Data, _data73_);
#line 696 "gitg-remote-notification.c"
	}
}

static gboolean
_gitg_remote_notification_remote_state___lambda108_ (Block73Data* _data73_)
{
	GitgRemoteNotification* self;
	gboolean result;
#line 121 "../gitg/gitg-remote-notification.vala"
	self = _data73_->self;
#line 122 "../gitg/gitg-remote-notification.vala"
	switch (_data73_->value) {
#line 122 "../gitg/gitg-remote-notification.vala"
		case GITG_REMOTE_STATE_CONNECTING:
#line 711 "gitg-remote-notification.c"
		{
			GtkImage* _tmp0_;
#line 125 "../gitg/gitg-remote-notification.vala"
			_tmp0_ = self->priv->d_image_icon;
#line 125 "../gitg/gitg-remote-notification.vala"
			g_object_set (_tmp0_, "icon-name", "network-wireless-acquiring-symbolic", NULL);
#line 126 "../gitg/gitg-remote-notification.vala"
			break;
#line 720 "gitg-remote-notification.c"
		}
#line 122 "../gitg/gitg-remote-notification.vala"
		case GITG_REMOTE_STATE_CONNECTED:
#line 724 "gitg-remote-notification.c"
		{
			GtkImage* _tmp1_;
#line 128 "../gitg/gitg-remote-notification.vala"
			_tmp1_ = self->priv->d_image_icon;
#line 128 "../gitg/gitg-remote-notification.vala"
			g_object_set (_tmp1_, "icon-name", "network-idle-symbolic", NULL);
#line 129 "../gitg/gitg-remote-notification.vala"
			break;
#line 733 "gitg-remote-notification.c"
		}
#line 122 "../gitg/gitg-remote-notification.vala"
		case GITG_REMOTE_STATE_TRANSFERRING:
#line 737 "gitg-remote-notification.c"
		{
			GtkImage* _tmp2_;
#line 131 "../gitg/gitg-remote-notification.vala"
			_tmp2_ = self->priv->d_image_icon;
#line 131 "../gitg/gitg-remote-notification.vala"
			g_object_set (_tmp2_, "icon-name", "network-transmit-receive-symbolic", NULL);
#line 132 "../gitg/gitg-remote-notification.vala"
			break;
#line 746 "gitg-remote-notification.c"
		}
		default:
#line 122 "../gitg/gitg-remote-notification.vala"
		break;
#line 751 "gitg-remote-notification.c"
	}
#line 135 "../gitg/gitg-remote-notification.vala"
	result = FALSE;
#line 135 "../gitg/gitg-remote-notification.vala"
	return result;
#line 757 "gitg-remote-notification.c"
}

static gboolean
__gitg_remote_notification_remote_state___lambda108__gsource_func (gpointer self)
{
	gboolean result;
	result = _gitg_remote_notification_remote_state___lambda108_ (self);
#line 121 "../gitg/gitg-remote-notification.vala"
	return result;
#line 767 "gitg-remote-notification.c"
}

void
gitg_remote_notification_set_remote_state (GitgRemoteNotification* self,
                                           GitgRemoteState value)
{
	Block73Data* _data73_;
#line 119 "../gitg/gitg-remote-notification.vala"
	g_return_if_fail (self != NULL);
#line 119 "../gitg/gitg-remote-notification.vala"
	_data73_ = g_slice_new0 (Block73Data);
#line 119 "../gitg/gitg-remote-notification.vala"
	_data73_->_ref_count_ = 1;
#line 119 "../gitg/gitg-remote-notification.vala"
	_data73_->self = g_object_ref (self);
#line 119 "../gitg/gitg-remote-notification.vala"
	_data73_->value = value;
#line 121 "../gitg/gitg-remote-notification.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __gitg_remote_notification_remote_state___lambda108__gsource_func, block73_data_ref (_data73_), block73_data_unref);
#line 119 "../gitg/gitg-remote-notification.vala"
	block73_data_unref (_data73_);
#line 119 "../gitg/gitg-remote-notification.vala"
	_data73_ = NULL;
#line 119 "../gitg/gitg-remote-notification.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_remote_notification_properties[GITG_REMOTE_NOTIFICATION_REMOTE_STATE_PROPERTY]);
#line 793 "gitg-remote-notification.c"
}

static void
gitg_remote_notification_class_init (GitgRemoteNotificationClass * klass,
                                     gpointer klass_data)
{
#line 24 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_parent_class = g_type_class_peek_parent (klass);
#line 24 "../gitg/gitg-remote-notification.vala"
	g_type_class_adjust_private_offset (klass, &GitgRemoteNotification_private_offset);
#line 24 "../gitg/gitg-remote-notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_remote_notification_get_property;
#line 24 "../gitg/gitg-remote-notification.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_remote_notification_set_property;
#line 24 "../gitg/gitg-remote-notification.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_remote_notification_finalize;
#line 24 "../gitg/gitg-remote-notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REMOTE_NOTIFICATION_WIDGET_PROPERTY, gitg_remote_notification_properties[GITG_REMOTE_NOTIFICATION_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../gitg/gitg-remote-notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REMOTE_NOTIFICATION_TEXT_PROPERTY, gitg_remote_notification_properties[GITG_REMOTE_NOTIFICATION_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../gitg/gitg-remote-notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REMOTE_NOTIFICATION_REMOTE_STATE_PROPERTY, gitg_remote_notification_properties[GITG_REMOTE_NOTIFICATION_REMOTE_STATE_PROPERTY] = g_param_spec_enum ("remote-state", "remote-state", "remote-state", GITG_TYPE_REMOTE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 24 "../gitg/gitg-remote-notification.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/gitg/ui/gitg-remote-notification.ui");
#line 24 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_signals[GITG_REMOTE_NOTIFICATION_CANCEL_SIGNAL] = g_signal_new ("cancel", GITG_TYPE_REMOTE_NOTIFICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../gitg/gitg-remote-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image_icon", FALSE, GitgRemoteNotification_private_offset + G_STRUCT_OFFSET (GitgRemoteNotificationPrivate, d_image_icon));
#line 24 "../gitg/gitg-remote-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "label_text", FALSE, GitgRemoteNotification_private_offset + G_STRUCT_OFFSET (GitgRemoteNotificationPrivate, d_label_text));
#line 24 "../gitg/gitg-remote-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_cancel", FALSE, GitgRemoteNotification_private_offset + G_STRUCT_OFFSET (GitgRemoteNotificationPrivate, d_button_cancel));
#line 24 "../gitg/gitg-remote-notification.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_button_cancel_clicked", G_CALLBACK(_gitg_remote_notification_on_button_cancel_clicked_gtk_button_clicked));
#line 828 "gitg-remote-notification.c"
}

static void
gitg_remote_notification_gitg_ext_notification_interface_init (GitgExtNotificationIface * iface,
                                                               gpointer iface_data)
{
#line 24 "../gitg/gitg-remote-notification.vala"
	gitg_remote_notification_gitg_ext_notification_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../gitg/gitg-remote-notification.vala"
	iface->get_widget = gitg_remote_notification_real_get_widget;
#line 839 "gitg-remote-notification.c"
}

static void
gitg_remote_notification_instance_init (GitgRemoteNotification * self,
                                        gpointer klass)
{
#line 24 "../gitg/gitg-remote-notification.vala"
	self->priv = gitg_remote_notification_get_instance_private (self);
#line 24 "../gitg/gitg-remote-notification.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 850 "gitg-remote-notification.c"
}

static void
gitg_remote_notification_finalize (GObject * obj)
{
	GitgRemoteNotification * self;
#line 24 "../gitg/gitg-remote-notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_REMOTE_NOTIFICATION, GitgRemoteNotification);
#line 29 "../gitg/gitg-remote-notification.vala"
	_g_object_unref0 (self->priv->d_remote);
#line 44 "../gitg/gitg-remote-notification.vala"
	_g_free0 (self->priv->d_text);
#line 24 "../gitg/gitg-remote-notification.vala"
	G_OBJECT_CLASS (gitg_remote_notification_parent_class)->finalize (obj);
#line 865 "gitg-remote-notification.c"
}

 G_GNUC_NO_INLINE static GType
gitg_remote_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgRemoteNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_remote_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgRemoteNotification), 0, (GInstanceInitFunc) gitg_remote_notification_instance_init, NULL };
	static const GInterfaceInfo gitg_ext_notification_info = { (GInterfaceInitFunc) gitg_remote_notification_gitg_ext_notification_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gitg_remote_notification_type_id;
	gitg_remote_notification_type_id = g_type_register_static (GITG_TYPE_PROGRESS_BIN, "GitgRemoteNotification", &g_define_type_info, 0);
	g_type_add_interface_static (gitg_remote_notification_type_id, GITG_EXT_TYPE_NOTIFICATION, &gitg_ext_notification_info);
	GitgRemoteNotification_private_offset = g_type_add_instance_private (gitg_remote_notification_type_id, sizeof (GitgRemoteNotificationPrivate));
	return gitg_remote_notification_type_id;
}

GType
gitg_remote_notification_get_type (void)
{
	static gsize gitg_remote_notification_type_id__once = 0;
	if (g_once_init_enter (&gitg_remote_notification_type_id__once)) {
		GType gitg_remote_notification_type_id;
		gitg_remote_notification_type_id = gitg_remote_notification_get_type_once ();
		g_once_init_leave (&gitg_remote_notification_type_id__once, gitg_remote_notification_type_id);
	}
	return gitg_remote_notification_type_id__once;
}

static void
_vala_gitg_remote_notification_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GitgRemoteNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_REMOTE_NOTIFICATION, GitgRemoteNotification);
#line 24 "../gitg/gitg-remote-notification.vala"
	switch (property_id) {
#line 24 "../gitg/gitg-remote-notification.vala"
		case GITG_REMOTE_NOTIFICATION_WIDGET_PROPERTY:
#line 24 "../gitg/gitg-remote-notification.vala"
		g_value_take_object (value, gitg_ext_notification_get_widget ((GitgExtNotification*) self));
#line 24 "../gitg/gitg-remote-notification.vala"
		break;
#line 24 "../gitg/gitg-remote-notification.vala"
		case GITG_REMOTE_NOTIFICATION_TEXT_PROPERTY:
#line 24 "../gitg/gitg-remote-notification.vala"
		g_value_set_string (value, gitg_remote_notification_get_text (self));
#line 24 "../gitg/gitg-remote-notification.vala"
		break;
#line 914 "gitg-remote-notification.c"
		default:
#line 24 "../gitg/gitg-remote-notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../gitg/gitg-remote-notification.vala"
		break;
#line 920 "gitg-remote-notification.c"
	}
}

static void
_vala_gitg_remote_notification_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GitgRemoteNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_REMOTE_NOTIFICATION, GitgRemoteNotification);
#line 24 "../gitg/gitg-remote-notification.vala"
	switch (property_id) {
#line 24 "../gitg/gitg-remote-notification.vala"
		case GITG_REMOTE_NOTIFICATION_TEXT_PROPERTY:
#line 24 "../gitg/gitg-remote-notification.vala"
		gitg_remote_notification_set_text (self, g_value_get_string (value));
#line 24 "../gitg/gitg-remote-notification.vala"
		break;
#line 24 "../gitg/gitg-remote-notification.vala"
		case GITG_REMOTE_NOTIFICATION_REMOTE_STATE_PROPERTY:
#line 24 "../gitg/gitg-remote-notification.vala"
		gitg_remote_notification_set_remote_state (self, g_value_get_enum (value));
#line 24 "../gitg/gitg-remote-notification.vala"
		break;
#line 946 "gitg-remote-notification.c"
		default:
#line 24 "../gitg/gitg-remote-notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../gitg/gitg-remote-notification.vala"
		break;
#line 952 "gitg-remote-notification.c"
	}
}

