/* gitg-textconv.c generated by valac 0.56.3, the Vala compiler
 * generated from gitg-textconv.vala, do not modify */

/*
 *
 * Copyright (C) 2021 - Alberto Fanjul
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <libgit2-glib/ggit.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GgitOId_free0(var) ((var == NULL) ? NULL : (var = (_vala_GgitOId_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _GitgParamSpecTextConv GitgParamSpecTextConv;

struct _GitgParamSpecTextConv {
	GParamSpec parent_instance;
};

static gpointer gitg_text_conv_parent_class = NULL;

static gchar* gitg_text_conv_get_textconv_command (GitgRepository* repository,
                                            GgitDiffFile* file);
static guint8* _vala_array_dup24 (guint8* self,
                           gssize length);
static GgitOId* _vala_GgitOId_copy (GgitOId* self);
static void _vala_GgitOId_free (GgitOId* self);
static guint8* _vala_array_dup25 (guint8* self,
                           gssize length);
static guint8* _vala_array_dup26 (guint8* self,
                           gssize length);
static guint8* gitg_text_conv_textconv (const gchar* command,
                                 guint8* data,
                                 gint data_length1,
                                 gint* result_length1);
static guint8* _vala_array_dup27 (guint8* self,
                           gssize length);
static void _g_free_gdestroy_notify (void* data);
static guint8* _vala_array_dup28 (guint8* self,
                           gssize length);
static void gitg_text_conv_finalize (GitgTextConv * obj);
static GType gitg_text_conv_get_type_once (void);

gboolean
gitg_text_conv_has_textconv_command (GitgRepository* repository,
                                     GgitDiffFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 26 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, FALSE);
#line 26 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 28 "../libgitg/gitg-textconv.vala"
	_tmp0_ = gitg_text_conv_get_textconv_command (repository, file);
#line 28 "../libgitg/gitg-textconv.vala"
	_tmp1_ = _tmp0_;
#line 28 "../libgitg/gitg-textconv.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 28 "../libgitg/gitg-textconv.vala"
	_g_free0 (_tmp1_);
#line 28 "../libgitg/gitg-textconv.vala"
	result = _tmp2_;
#line 28 "../libgitg/gitg-textconv.vala"
	return result;
#line 89 "gitg-textconv.c"
}

static gchar*
gitg_text_conv_get_textconv_command (GitgRepository* repository,
                                     GgitDiffFile* file)
{
	gchar* command = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* diffattr = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 31 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 31 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 33 "../libgitg/gitg-textconv.vala"
	command = NULL;
#line 34 "../libgitg/gitg-textconv.vala"
	_tmp0_ = ggit_diff_file_get_path (file);
#line 34 "../libgitg/gitg-textconv.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 34 "../libgitg/gitg-textconv.vala"
	path = _tmp1_;
#line 35 "../libgitg/gitg-textconv.vala"
	_tmp2_ = path;
#line 35 "../libgitg/gitg-textconv.vala"
	_tmp3_ = ggit_repository_get_attribute ((GgitRepository*) repository, _tmp2_, "diff", GGIT_ATTRIBUTE_CHECK_FILE_THEN_INDEX, &_inner_error0_);
#line 35 "../libgitg/gitg-textconv.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 35 "../libgitg/gitg-textconv.vala"
	diffattr = _tmp4_;
#line 35 "../libgitg/gitg-textconv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "../libgitg/gitg-textconv.vala"
		_g_free0 (path);
#line 35 "../libgitg/gitg-textconv.vala"
		_g_free0 (command);
#line 35 "../libgitg/gitg-textconv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../libgitg/gitg-textconv.vala"
		g_clear_error (&_inner_error0_);
#line 35 "../libgitg/gitg-textconv.vala"
		return NULL;
#line 139 "gitg-textconv.c"
	}
#line 36 "../libgitg/gitg-textconv.vala"
	_tmp5_ = diffattr;
#line 36 "../libgitg/gitg-textconv.vala"
	if (_tmp5_ != NULL) {
#line 145 "gitg-textconv.c"
		gchar* textconv_key = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 38 "../libgitg/gitg-textconv.vala"
		_tmp6_ = diffattr;
#line 38 "../libgitg/gitg-textconv.vala"
		_tmp7_ = g_strdup_printf ("diff.%s.textconv", _tmp6_);
#line 38 "../libgitg/gitg-textconv.vala"
		textconv_key = _tmp7_;
#line 155 "gitg-textconv.c"
		{
			GgitConfig* _tmp8_ = NULL;
			GgitConfig* _tmp9_;
			const gchar* _tmp10_ = NULL;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 41 "../libgitg/gitg-textconv.vala"
			_tmp9_ = ggit_repository_get_config ((GgitRepository*) repository, &_inner_error0_);
#line 41 "../libgitg/gitg-textconv.vala"
			_tmp8_ = _tmp9_;
#line 41 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "gitg-textconv.c"
				goto __catch0_g_error;
			}
#line 41 "../libgitg/gitg-textconv.vala"
			_tmp11_ = textconv_key;
#line 41 "../libgitg/gitg-textconv.vala"
			_tmp12_ = ggit_config_get_string (_tmp8_, _tmp11_, &_inner_error0_);
#line 41 "../libgitg/gitg-textconv.vala"
			_tmp10_ = _tmp12_;
#line 41 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 41 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (_tmp8_);
#line 182 "gitg-textconv.c"
				goto __catch0_g_error;
			}
#line 41 "../libgitg/gitg-textconv.vala"
			_tmp13_ = g_strdup (_tmp10_);
#line 41 "../libgitg/gitg-textconv.vala"
			_g_free0 (command);
#line 41 "../libgitg/gitg-textconv.vala"
			command = _tmp13_;
#line 39 "../libgitg/gitg-textconv.vala"
			_g_object_unref0 (_tmp8_);
#line 193 "gitg-textconv.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 39 "../libgitg/gitg-textconv.vala"
			g_clear_error (&_inner_error0_);
#line 200 "gitg-textconv.c"
		}
		__finally0:
#line 39 "../libgitg/gitg-textconv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../libgitg/gitg-textconv.vala"
			_g_free0 (textconv_key);
#line 39 "../libgitg/gitg-textconv.vala"
			_g_free0 (diffattr);
#line 39 "../libgitg/gitg-textconv.vala"
			_g_free0 (path);
#line 39 "../libgitg/gitg-textconv.vala"
			_g_free0 (command);
#line 39 "../libgitg/gitg-textconv.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../libgitg/gitg-textconv.vala"
			g_clear_error (&_inner_error0_);
#line 39 "../libgitg/gitg-textconv.vala"
			return NULL;
#line 219 "gitg-textconv.c"
		}
#line 36 "../libgitg/gitg-textconv.vala"
		_g_free0 (textconv_key);
#line 223 "gitg-textconv.c"
	}
#line 47 "../libgitg/gitg-textconv.vala"
	result = command;
#line 47 "../libgitg/gitg-textconv.vala"
	_g_free0 (diffattr);
#line 47 "../libgitg/gitg-textconv.vala"
	_g_free0 (path);
#line 47 "../libgitg/gitg-textconv.vala"
	return result;
#line 233 "gitg-textconv.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1563 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1564 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1564 "glib-2.0.vapi"
	res_length1 = -1;
#line 1564 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1565 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1565 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1565 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1566 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1566 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1566 "glib-2.0.vapi"
	if (result_length1) {
#line 1566 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 270 "gitg-textconv.c"
	}
#line 1566 "glib-2.0.vapi"
	result = _tmp2_;
#line 1566 "glib-2.0.vapi"
	return result;
#line 276 "gitg-textconv.c"
}

static guint8*
_vala_array_dup24 (guint8* self,
                   gssize length)
{
#line 52 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 52 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 287 "gitg-textconv.c"
	}
#line 52 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 291 "gitg-textconv.c"
}

static GgitOId*
_vala_GgitOId_copy (GgitOId* self)
{
#line 55 "../libgitg/gitg-textconv.vala"
	return g_boxed_copy (ggit_oid_get_type (), self);
#line 299 "gitg-textconv.c"
}

static gpointer
__vala_GgitOId_copy0 (gpointer self)
{
#line 55 "../libgitg/gitg-textconv.vala"
	return self ? _vala_GgitOId_copy (self) : NULL;
#line 307 "gitg-textconv.c"
}

static void
_vala_GgitOId_free (GgitOId* self)
{
#line 58 "../libgitg/gitg-textconv.vala"
	g_boxed_free (ggit_oid_get_type (), self);
#line 315 "gitg-textconv.c"
}

static guint8*
_vala_array_dup25 (guint8* self,
                   gssize length)
{
#line 59 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 59 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 326 "gitg-textconv.c"
	}
#line 59 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 330 "gitg-textconv.c"
}

guint8*
gitg_text_conv_get_textconv_content (GitgRepository* repository,
                                     GgitDiffFile* file,
                                     gint* result_length1)
{
	guint8* content = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint content_length1;
	gint _content_size_;
	guint8* _tmp16_;
	gint _tmp16__length1;
	GError* _inner_error0_ = NULL;
	guint8* result;
#line 50 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 50 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 52 "../libgitg/gitg-textconv.vala"
	_tmp0_ = string_get_data ("", &_tmp1_);
#line 52 "../libgitg/gitg-textconv.vala"
	_tmp0__length1 = _tmp1_;
#line 52 "../libgitg/gitg-textconv.vala"
	_tmp2_ = _tmp0_;
#line 52 "../libgitg/gitg-textconv.vala"
	_tmp2__length1 = _tmp0__length1;
#line 52 "../libgitg/gitg-textconv.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup24 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 52 "../libgitg/gitg-textconv.vala"
	_tmp3__length1 = _tmp2__length1;
#line 52 "../libgitg/gitg-textconv.vala"
	content = _tmp3_;
#line 52 "../libgitg/gitg-textconv.vala"
	content_length1 = _tmp3__length1;
#line 52 "../libgitg/gitg-textconv.vala"
	_content_size_ = content_length1;
#line 53 "../libgitg/gitg-textconv.vala"
	if (file != NULL) {
#line 376 "gitg-textconv.c"
		GgitOId* oid = NULL;
		GgitOId* _tmp4_;
		GgitOId* _tmp5_;
		guint8* raw_content = NULL;
		gint raw_content_length1;
		gint _raw_content_size_;
		GgitOId* _tmp6_;
		guint8* _tmp13_;
		gint _tmp13__length1;
		gint _tmp14_ = 0;
		guint8* _tmp15_;
#line 55 "../libgitg/gitg-textconv.vala"
		_tmp4_ = ggit_diff_file_get_oid (file);
#line 55 "../libgitg/gitg-textconv.vala"
		_tmp5_ = __vala_GgitOId_copy0 (_tmp4_);
#line 55 "../libgitg/gitg-textconv.vala"
		oid = _tmp5_;
#line 56 "../libgitg/gitg-textconv.vala"
		raw_content = NULL;
#line 56 "../libgitg/gitg-textconv.vala"
		raw_content_length1 = 0;
#line 56 "../libgitg/gitg-textconv.vala"
		_raw_content_size_ = raw_content_length1;
#line 57 "../libgitg/gitg-textconv.vala"
		_tmp6_ = oid;
#line 57 "../libgitg/gitg-textconv.vala"
		if (!ggit_oid_is_zero (_tmp6_)) {
#line 404 "gitg-textconv.c"
			GgitBlob* blob = NULL;
			GgitOId* _tmp7_;
			gpointer _tmp8_;
			GgitBlob* _tmp9_;
			gsize _tmp10_ = 0;
			guint8* _tmp11_;
			guint8* _tmp12_;
			gint _tmp12__length1;
#line 58 "../libgitg/gitg-textconv.vala"
			_tmp7_ = oid;
#line 58 "../libgitg/gitg-textconv.vala"
			_tmp8_ = gitg_repository_lookup (repository, ggit_blob_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp7_, &_inner_error0_);
#line 58 "../libgitg/gitg-textconv.vala"
			blob = (GgitBlob*) _tmp8_;
#line 58 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "../libgitg/gitg-textconv.vala"
				raw_content = (g_free (raw_content), NULL);
#line 58 "../libgitg/gitg-textconv.vala"
				__vala_GgitOId_free0 (oid);
#line 58 "../libgitg/gitg-textconv.vala"
				content = (g_free (content), NULL);
#line 58 "../libgitg/gitg-textconv.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 58 "../libgitg/gitg-textconv.vala"
				g_clear_error (&_inner_error0_);
#line 58 "../libgitg/gitg-textconv.vala"
				return NULL;
#line 433 "gitg-textconv.c"
			}
#line 59 "../libgitg/gitg-textconv.vala"
			_tmp9_ = blob;
#line 59 "../libgitg/gitg-textconv.vala"
			_tmp11_ = ggit_blob_get_raw_content (_tmp9_, &_tmp10_);
#line 59 "../libgitg/gitg-textconv.vala"
			_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup25 (_tmp11_, _tmp10_) : _tmp11_;
#line 59 "../libgitg/gitg-textconv.vala"
			_tmp12__length1 = _tmp10_;
#line 59 "../libgitg/gitg-textconv.vala"
			raw_content = (g_free (raw_content), NULL);
#line 59 "../libgitg/gitg-textconv.vala"
			raw_content = _tmp12_;
#line 59 "../libgitg/gitg-textconv.vala"
			raw_content_length1 = _tmp12__length1;
#line 59 "../libgitg/gitg-textconv.vala"
			_raw_content_size_ = raw_content_length1;
#line 57 "../libgitg/gitg-textconv.vala"
			_g_object_unref0 (blob);
#line 453 "gitg-textconv.c"
		}
#line 62 "../libgitg/gitg-textconv.vala"
		_tmp13_ = raw_content;
#line 62 "../libgitg/gitg-textconv.vala"
		_tmp13__length1 = raw_content_length1;
#line 62 "../libgitg/gitg-textconv.vala"
		_tmp15_ = gitg_text_conv_get_textconv_content_from_raw (repository, file, _tmp13_, (gint) _tmp13__length1, &_tmp14_);
#line 62 "../libgitg/gitg-textconv.vala"
		content = (g_free (content), NULL);
#line 62 "../libgitg/gitg-textconv.vala"
		content = _tmp15_;
#line 62 "../libgitg/gitg-textconv.vala"
		content_length1 = _tmp14_;
#line 62 "../libgitg/gitg-textconv.vala"
		_content_size_ = content_length1;
#line 53 "../libgitg/gitg-textconv.vala"
		raw_content = (g_free (raw_content), NULL);
#line 53 "../libgitg/gitg-textconv.vala"
		__vala_GgitOId_free0 (oid);
#line 473 "gitg-textconv.c"
	}
#line 64 "../libgitg/gitg-textconv.vala"
	_tmp16_ = content;
#line 64 "../libgitg/gitg-textconv.vala"
	_tmp16__length1 = content_length1;
#line 64 "../libgitg/gitg-textconv.vala"
	if (result_length1) {
#line 64 "../libgitg/gitg-textconv.vala"
		*result_length1 = _tmp16__length1;
#line 483 "gitg-textconv.c"
	}
#line 64 "../libgitg/gitg-textconv.vala"
	result = _tmp16_;
#line 64 "../libgitg/gitg-textconv.vala"
	return result;
#line 489 "gitg-textconv.c"
}

static guint8*
_vala_array_dup26 (guint8* self,
                   gssize length)
{
#line 69 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 69 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 500 "gitg-textconv.c"
	}
#line 69 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 504 "gitg-textconv.c"
}

guint8*
gitg_text_conv_get_textconv_content_from_raw (GitgRepository* repository,
                                              GgitDiffFile* file,
                                              guint8* raw_content,
                                              gint raw_content_length1,
                                              gint* result_length1)
{
	guint8* content = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint content_length1;
	gint _content_size_;
	guint8* _tmp9_;
	gint _tmp9__length1;
	guint8* result;
#line 67 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 67 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 69 "../libgitg/gitg-textconv.vala"
	_tmp0_ = string_get_data ("", &_tmp1_);
#line 69 "../libgitg/gitg-textconv.vala"
	_tmp0__length1 = _tmp1_;
#line 69 "../libgitg/gitg-textconv.vala"
	_tmp2_ = _tmp0_;
#line 69 "../libgitg/gitg-textconv.vala"
	_tmp2__length1 = _tmp0__length1;
#line 69 "../libgitg/gitg-textconv.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup26 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 69 "../libgitg/gitg-textconv.vala"
	_tmp3__length1 = _tmp2__length1;
#line 69 "../libgitg/gitg-textconv.vala"
	content = _tmp3_;
#line 69 "../libgitg/gitg-textconv.vala"
	content_length1 = _tmp3__length1;
#line 69 "../libgitg/gitg-textconv.vala"
	_content_size_ = content_length1;
#line 70 "../libgitg/gitg-textconv.vala"
	if (raw_content != NULL) {
#line 551 "gitg-textconv.c"
		gchar* command = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 72 "../libgitg/gitg-textconv.vala"
		_tmp4_ = gitg_text_conv_get_textconv_command (repository, file);
#line 72 "../libgitg/gitg-textconv.vala"
		command = _tmp4_;
#line 73 "../libgitg/gitg-textconv.vala"
		_tmp5_ = command;
#line 73 "../libgitg/gitg-textconv.vala"
		if (_tmp5_ != NULL) {
#line 563 "gitg-textconv.c"
			const gchar* _tmp6_;
			gint _tmp7_ = 0;
			guint8* _tmp8_;
#line 75 "../libgitg/gitg-textconv.vala"
			_tmp6_ = command;
#line 75 "../libgitg/gitg-textconv.vala"
			_tmp8_ = gitg_text_conv_textconv (_tmp6_, raw_content, (gint) raw_content_length1, &_tmp7_);
#line 75 "../libgitg/gitg-textconv.vala"
			content = (g_free (content), NULL);
#line 75 "../libgitg/gitg-textconv.vala"
			content = _tmp8_;
#line 75 "../libgitg/gitg-textconv.vala"
			content_length1 = _tmp7_;
#line 75 "../libgitg/gitg-textconv.vala"
			_content_size_ = content_length1;
#line 579 "gitg-textconv.c"
		}
#line 70 "../libgitg/gitg-textconv.vala"
		_g_free0 (command);
#line 583 "gitg-textconv.c"
	}
#line 78 "../libgitg/gitg-textconv.vala"
	_tmp9_ = content;
#line 78 "../libgitg/gitg-textconv.vala"
	_tmp9__length1 = content_length1;
#line 78 "../libgitg/gitg-textconv.vala"
	if (result_length1) {
#line 78 "../libgitg/gitg-textconv.vala"
		*result_length1 = _tmp9__length1;
#line 593 "gitg-textconv.c"
	}
#line 78 "../libgitg/gitg-textconv.vala"
	result = _tmp9_;
#line 78 "../libgitg/gitg-textconv.vala"
	return result;
#line 599 "gitg-textconv.c"
}

static guint8*
_vala_array_dup27 (guint8* self,
                   gssize length)
{
#line 85 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 85 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 610 "gitg-textconv.c"
	}
#line 85 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 614 "gitg-textconv.c"
}

static void
_g_free_gdestroy_notify (void* data)
{
#line 85 "../libgitg/gitg-textconv.vala"
	g_free (data);
#line 622 "gitg-textconv.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 88 "../libgitg/gitg-textconv.vala"
	return self ? g_object_ref (self) : NULL;
#line 630 "gitg-textconv.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 652 "gitg-textconv.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 656 "gitg-textconv.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 662 "gitg-textconv.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 666 "gitg-textconv.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 670 "gitg-textconv.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 678 "gitg-textconv.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 706 "gitg-textconv.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 715 "gitg-textconv.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 729 "gitg-textconv.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 738 "gitg-textconv.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 752 "gitg-textconv.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 761 "gitg-textconv.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 770 "gitg-textconv.c"
}

static guint8*
_vala_array_dup28 (guint8* self,
                   gssize length)
{
#line 100 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 100 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 781 "gitg-textconv.c"
	}
#line 100 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 785 "gitg-textconv.c"
}

static guint8*
gitg_text_conv_textconv (const gchar* command,
                         guint8* data,
                         gint data_length1,
                         gint* result_length1)
{
	GSubprocess* subproc = NULL;
	GSubprocess* _tmp0_;
	GMemoryInputStream* input = NULL;
	guint8* _tmp1_;
	gint _tmp1__length1;
	GMemoryInputStream* _tmp2_;
	GSubprocess* _tmp3_;
	GOutputStream* _tmp4_;
	GMemoryInputStream* _tmp5_;
	GInputStream* end_pipe = NULL;
	GSubprocess* _tmp6_;
	GInputStream* _tmp7_;
	GInputStream* _tmp8_;
	GDataInputStream* output = NULL;
	GInputStream* _tmp9_;
	GDataInputStream* _tmp10_;
	gchar* lines = NULL;
	gchar* _tmp11_;
	gchar* line = NULL;
	const gchar* _tmp26_;
	guint8* _tmp27_;
	gint _tmp27__length1;
	gint _tmp28_ = 0;
	guint8* _tmp29_;
	gint _tmp29__length1;
	guint8* _tmp30_;
	gint _tmp30__length1;
	guint8* _tmp31_;
	gint _tmp31__length1;
	GError* _inner_error0_ = NULL;
	guint8* result;
#line 81 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 83 "../libgitg/gitg-textconv.vala"
	_tmp0_ = g_subprocess_new (G_SUBPROCESS_FLAGS_STDIN_PIPE | G_SUBPROCESS_FLAGS_STDOUT_PIPE, &_inner_error0_, command, "/dev/stdin", NULL);
#line 83 "../libgitg/gitg-textconv.vala"
	subproc = _tmp0_;
#line 83 "../libgitg/gitg-textconv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "../libgitg/gitg-textconv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../libgitg/gitg-textconv.vala"
		g_clear_error (&_inner_error0_);
#line 83 "../libgitg/gitg-textconv.vala"
		return NULL;
#line 839 "gitg-textconv.c"
	}
#line 85 "../libgitg/gitg-textconv.vala"
	_tmp1_ = (data != NULL) ? _vala_array_dup27 (data, data_length1) : data;
#line 85 "../libgitg/gitg-textconv.vala"
	_tmp1__length1 = data_length1;
#line 85 "../libgitg/gitg-textconv.vala"
	_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp1_, _tmp1__length1, _g_free_gdestroy_notify);
#line 85 "../libgitg/gitg-textconv.vala"
	input = _tmp2_;
#line 87 "../libgitg/gitg-textconv.vala"
	_tmp3_ = subproc;
#line 87 "../libgitg/gitg-textconv.vala"
	_tmp4_ = g_subprocess_get_stdin_pipe (_tmp3_);
#line 87 "../libgitg/gitg-textconv.vala"
	_tmp5_ = input;
#line 87 "../libgitg/gitg-textconv.vala"
	g_output_stream_splice (_tmp4_, (GInputStream*) _tmp5_, G_OUTPUT_STREAM_SPLICE_CLOSE_TARGET, NULL, &_inner_error0_);
#line 87 "../libgitg/gitg-textconv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (input);
#line 87 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (subproc);
#line 87 "../libgitg/gitg-textconv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../libgitg/gitg-textconv.vala"
		g_clear_error (&_inner_error0_);
#line 87 "../libgitg/gitg-textconv.vala"
		return NULL;
#line 869 "gitg-textconv.c"
	}
#line 88 "../libgitg/gitg-textconv.vala"
	_tmp6_ = subproc;
#line 88 "../libgitg/gitg-textconv.vala"
	_tmp7_ = g_subprocess_get_stdout_pipe (_tmp6_);
#line 88 "../libgitg/gitg-textconv.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 88 "../libgitg/gitg-textconv.vala"
	end_pipe = _tmp8_;
#line 89 "../libgitg/gitg-textconv.vala"
	_tmp9_ = end_pipe;
#line 89 "../libgitg/gitg-textconv.vala"
	_tmp10_ = g_data_input_stream_new (_tmp9_);
#line 89 "../libgitg/gitg-textconv.vala"
	output = _tmp10_;
#line 91 "../libgitg/gitg-textconv.vala"
	_tmp11_ = g_strdup ("");
#line 91 "../libgitg/gitg-textconv.vala"
	lines = _tmp11_;
#line 92 "../libgitg/gitg-textconv.vala"
	line = NULL;
#line 891 "gitg-textconv.c"
	{
		gboolean _tmp12_ = FALSE;
#line 93 "../libgitg/gitg-textconv.vala"
		_tmp12_ = TRUE;
#line 93 "../libgitg/gitg-textconv.vala"
		while (TRUE) {
#line 898 "gitg-textconv.c"
			gchar* _tmp14_ = NULL;
			GDataInputStream* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
#line 93 "../libgitg/gitg-textconv.vala"
			if (!_tmp12_) {
#line 906 "gitg-textconv.c"
				const gchar* _tmp13_;
#line 99 "../libgitg/gitg-textconv.vala"
				_tmp13_ = line;
#line 99 "../libgitg/gitg-textconv.vala"
				if (!(_tmp13_ != NULL)) {
#line 99 "../libgitg/gitg-textconv.vala"
					break;
#line 914 "gitg-textconv.c"
				}
			}
#line 93 "../libgitg/gitg-textconv.vala"
			_tmp12_ = FALSE;
#line 94 "../libgitg/gitg-textconv.vala"
			_tmp15_ = output;
#line 94 "../libgitg/gitg-textconv.vala"
			_tmp16_ = g_data_input_stream_read_line (_tmp15_, NULL, NULL, &_inner_error0_);
#line 94 "../libgitg/gitg-textconv.vala"
			_tmp14_ = _tmp16_;
#line 94 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../libgitg/gitg-textconv.vala"
				_g_free0 (line);
#line 94 "../libgitg/gitg-textconv.vala"
				_g_free0 (lines);
#line 94 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (output);
#line 94 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (end_pipe);
#line 94 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (input);
#line 94 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (subproc);
#line 94 "../libgitg/gitg-textconv.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../libgitg/gitg-textconv.vala"
				g_clear_error (&_inner_error0_);
#line 94 "../libgitg/gitg-textconv.vala"
				return NULL;
#line 945 "gitg-textconv.c"
			}
#line 94 "../libgitg/gitg-textconv.vala"
			_tmp17_ = _tmp14_;
#line 94 "../libgitg/gitg-textconv.vala"
			_tmp14_ = NULL;
#line 94 "../libgitg/gitg-textconv.vala"
			_g_free0 (line);
#line 94 "../libgitg/gitg-textconv.vala"
			line = _tmp17_;
#line 95 "../libgitg/gitg-textconv.vala"
			_tmp18_ = line;
#line 95 "../libgitg/gitg-textconv.vala"
			if (_tmp18_ != NULL) {
#line 959 "gitg-textconv.c"
				const gchar* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
#line 96 "../libgitg/gitg-textconv.vala"
				_tmp19_ = line;
#line 96 "../libgitg/gitg-textconv.vala"
				_tmp20_ = string_replace (_tmp19_, "\f", "");
#line 96 "../libgitg/gitg-textconv.vala"
				_g_free0 (line);
#line 96 "../libgitg/gitg-textconv.vala"
				line = _tmp20_;
#line 97 "../libgitg/gitg-textconv.vala"
				_tmp21_ = lines;
#line 97 "../libgitg/gitg-textconv.vala"
				_tmp22_ = line;
#line 97 "../libgitg/gitg-textconv.vala"
				_tmp23_ = g_strconcat (_tmp22_, "\n", NULL);
#line 97 "../libgitg/gitg-textconv.vala"
				_tmp24_ = _tmp23_;
#line 97 "../libgitg/gitg-textconv.vala"
				_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
#line 97 "../libgitg/gitg-textconv.vala"
				_g_free0 (lines);
#line 97 "../libgitg/gitg-textconv.vala"
				lines = _tmp25_;
#line 97 "../libgitg/gitg-textconv.vala"
				_g_free0 (_tmp24_);
#line 991 "gitg-textconv.c"
			}
#line 93 "../libgitg/gitg-textconv.vala"
			_g_free0 (_tmp14_);
#line 995 "gitg-textconv.c"
		}
	}
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp26_ = lines;
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp27_ = string_get_data (_tmp26_, &_tmp28_);
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp27__length1 = _tmp28_;
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp29_ = _tmp27_;
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp29__length1 = _tmp27__length1;
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp30_ = (_tmp29_ != NULL) ? _vala_array_dup28 (_tmp29_, _tmp29__length1) : _tmp29_;
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp30__length1 = _tmp29__length1;
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp31_ = _tmp30_;
#line 100 "../libgitg/gitg-textconv.vala"
	_tmp31__length1 = _tmp30__length1;
#line 100 "../libgitg/gitg-textconv.vala"
	if (result_length1) {
#line 100 "../libgitg/gitg-textconv.vala"
		*result_length1 = _tmp31__length1;
#line 1020 "gitg-textconv.c"
	}
#line 100 "../libgitg/gitg-textconv.vala"
	result = _tmp31_;
#line 100 "../libgitg/gitg-textconv.vala"
	_g_free0 (line);
#line 100 "../libgitg/gitg-textconv.vala"
	_g_free0 (lines);
#line 100 "../libgitg/gitg-textconv.vala"
	_g_object_unref0 (output);
#line 100 "../libgitg/gitg-textconv.vala"
	_g_object_unref0 (end_pipe);
#line 100 "../libgitg/gitg-textconv.vala"
	_g_object_unref0 (input);
#line 100 "../libgitg/gitg-textconv.vala"
	_g_object_unref0 (subproc);
#line 100 "../libgitg/gitg-textconv.vala"
	return result;
#line 1038 "gitg-textconv.c"
}

GitgTextConv*
gitg_text_conv_construct (GType object_type)
{
	GitgTextConv* self = NULL;
#line 24 "../libgitg/gitg-textconv.vala"
	self = (GitgTextConv*) g_type_create_instance (object_type);
#line 24 "../libgitg/gitg-textconv.vala"
	return self;
#line 1049 "gitg-textconv.c"
}

GitgTextConv*
gitg_text_conv_new (void)
{
#line 24 "../libgitg/gitg-textconv.vala"
	return gitg_text_conv_construct (GITG_TYPE_TEXT_CONV);
#line 1057 "gitg-textconv.c"
}

static void
gitg_value_text_conv_init (GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	value->data[0].v_pointer = NULL;
#line 1065 "gitg-textconv.c"
}

static void
gitg_value_text_conv_free_value (GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	if (value->data[0].v_pointer) {
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_unref (value->data[0].v_pointer);
#line 1075 "gitg-textconv.c"
	}
}

static void
gitg_value_text_conv_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../libgitg/gitg-textconv.vala"
		dest_value->data[0].v_pointer = gitg_text_conv_ref (src_value->data[0].v_pointer);
#line 1087 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1091 "gitg-textconv.c"
	}
}

static gpointer
gitg_value_text_conv_peek_pointer (const GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	return value->data[0].v_pointer;
#line 1100 "gitg-textconv.c"
}

static gchar*
gitg_value_text_conv_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 24 "../libgitg/gitg-textconv.vala"
	if (collect_values[0].v_pointer) {
#line 1111 "gitg-textconv.c"
		GitgTextConv * object;
		object = collect_values[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../libgitg/gitg-textconv.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1118 "gitg-textconv.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../libgitg/gitg-textconv.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1122 "gitg-textconv.c"
		}
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = gitg_text_conv_ref (object);
#line 1126 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = NULL;
#line 1130 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 1134 "gitg-textconv.c"
}

static gchar*
gitg_value_text_conv_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	GitgTextConv ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
	if (!object_p) {
#line 24 "../libgitg/gitg-textconv.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1149 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../libgitg/gitg-textconv.vala"
		*object_p = NULL;
#line 1155 "gitg-textconv.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../libgitg/gitg-textconv.vala"
		*object_p = value->data[0].v_pointer;
#line 1159 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		*object_p = gitg_text_conv_ref (value->data[0].v_pointer);
#line 1163 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 1167 "gitg-textconv.c"
}

GParamSpec*
gitg_param_spec_text_conv (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	GitgParamSpecTextConv* spec;
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GITG_TYPE_TEXT_CONV), NULL);
#line 24 "../libgitg/gitg-textconv.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../libgitg/gitg-textconv.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../libgitg/gitg-textconv.vala"
	return G_PARAM_SPEC (spec);
#line 1186 "gitg-textconv.c"
}

gpointer
gitg_value_get_text_conv (const GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_TEXT_CONV), NULL);
#line 24 "../libgitg/gitg-textconv.vala"
	return value->data[0].v_pointer;
#line 1196 "gitg-textconv.c"
}

void
gitg_value_set_text_conv (GValue* value,
                          gpointer v_object)
{
	GitgTextConv * old;
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
	old = value->data[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
	if (v_object) {
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_ref (value->data[0].v_pointer);
#line 1218 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = NULL;
#line 1222 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	if (old) {
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_unref (old);
#line 1228 "gitg-textconv.c"
	}
}

void
gitg_value_take_text_conv (GValue* value,
                           gpointer v_object)
{
	GitgTextConv * old;
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
	old = value->data[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
	if (v_object) {
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = v_object;
#line 1249 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = NULL;
#line 1253 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	if (old) {
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_unref (old);
#line 1259 "gitg-textconv.c"
	}
}

static void
gitg_text_conv_class_init (GitgTextConvClass * klass,
                           gpointer klass_data)
{
#line 24 "../libgitg/gitg-textconv.vala"
	gitg_text_conv_parent_class = g_type_class_peek_parent (klass);
#line 24 "../libgitg/gitg-textconv.vala"
	((GitgTextConvClass *) klass)->finalize = gitg_text_conv_finalize;
#line 1271 "gitg-textconv.c"
}

static void
gitg_text_conv_instance_init (GitgTextConv * self,
                              gpointer klass)
{
#line 24 "../libgitg/gitg-textconv.vala"
	self->ref_count = 1;
#line 1280 "gitg-textconv.c"
}

static void
gitg_text_conv_finalize (GitgTextConv * obj)
{
	GitgTextConv * self;
#line 24 "../libgitg/gitg-textconv.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_TEXT_CONV, GitgTextConv);
#line 24 "../libgitg/gitg-textconv.vala"
	g_signal_handlers_destroy (self);
#line 1291 "gitg-textconv.c"
}

 G_GNUC_NO_INLINE static GType
gitg_text_conv_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gitg_value_text_conv_init, gitg_value_text_conv_free_value, gitg_value_text_conv_copy_value, gitg_value_text_conv_peek_pointer, "p", gitg_value_text_conv_collect_value, "p", gitg_value_text_conv_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GitgTextConvClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_text_conv_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgTextConv), 0, (GInstanceInitFunc) gitg_text_conv_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gitg_text_conv_type_id;
	gitg_text_conv_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GitgTextConv", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return gitg_text_conv_type_id;
}

GType
gitg_text_conv_get_type (void)
{
	static gsize gitg_text_conv_type_id__once = 0;
	if (g_once_init_enter (&gitg_text_conv_type_id__once)) {
		GType gitg_text_conv_type_id;
		gitg_text_conv_type_id = gitg_text_conv_get_type_once ();
		g_once_init_leave (&gitg_text_conv_type_id__once, gitg_text_conv_type_id);
	}
	return gitg_text_conv_type_id__once;
}

gpointer
gitg_text_conv_ref (gpointer instance)
{
	GitgTextConv * self;
	self = instance;
#line 24 "../libgitg/gitg-textconv.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../libgitg/gitg-textconv.vala"
	return instance;
#line 1326 "gitg-textconv.c"
}

void
gitg_text_conv_unref (gpointer instance)
{
	GitgTextConv * self;
	self = instance;
#line 24 "../libgitg/gitg-textconv.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../libgitg/gitg-textconv.vala"
		GITG_TEXT_CONV_GET_CLASS (self)->finalize (self);
#line 24 "../libgitg/gitg-textconv.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1340 "gitg-textconv.c"
	}
}

