/* gitg-repository-list-box.c generated by valac 0.56.3, the Vala compiler
 * generated from gitg-repository-list-box.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2012-2016 - Ignacio Casal Quinteiro
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <time.h>
#include <libgit2-glib/ggit.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include "ide.h"
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	GITG_REPOSITORY_LIST_BOX_0_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_MODE_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_BOOKMARKS_FROM_RECENT_FILES_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_LOCATION_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_HAS_SELECTION_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_NUM_PROPERTIES
};
static GParamSpec* gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_bookmark_file_free0(var) ((var == NULL) ? NULL : (var = (g_bookmark_file_free (var), NULL)))
#define _gtk_recent_info_unref0(var) ((var == NULL) ? NULL : (var = (gtk_recent_info_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block25Data Block25Data;
enum  {
	GITG_REPOSITORY_LIST_BOX_ROW_0_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_MODE_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_SELECTED_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_CAN_REMOVE_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_TIME_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_FRACTION_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_NAME_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_DIRNAME_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_BRANCH_NAME_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_LOADING_PROPERTY,
	GITG_REPOSITORY_LIST_BOX_ROW_NUM_PROPERTIES
};
static GParamSpec* gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_NUM_PROPERTIES];
#define __vala_GgitOId_free0(var) ((var == NULL) ? NULL : (var = (_vala_GgitOId_free (var), NULL)))
#define _ggit_tree_entry_unref0(var) ((var == NULL) ? NULL : (var = (ggit_tree_entry_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	GITG_REPOSITORY_LIST_BOX_ROW_REQUEST_REMOVE_SIGNAL,
	GITG_REPOSITORY_LIST_BOX_ROW_NUM_SIGNALS
};
static guint gitg_repository_list_box_row_signals[GITG_REPOSITORY_LIST_BOX_ROW_NUM_SIGNALS] = {0};
enum  {
	GITG_REPOSITORY_LIST_BOX_REPOSITORY_ACTIVATED_SIGNAL,
	GITG_REPOSITORY_LIST_BOX_SHOW_ERROR_SIGNAL,
	GITG_REPOSITORY_LIST_BOX_NUM_SIGNALS
};
static guint gitg_repository_list_box_signals[GITG_REPOSITORY_LIST_BOX_NUM_SIGNALS] = {0};

struct _GitgRepositoryListBoxPrivate {
	gchar* d_filter_text;
	GitgSelectionMode _mode;
	gboolean _bookmarks_from_recent_files;
	GFile* d_location;
	guint d_save_repository_bookmarks_id;
	GBookmarkFile* d_bookmark_file;
};

struct _Block25Data {
	int _ref_count_;
	GitgRepositoryListBox* self;
	GFile* workdir;
	GitgRepositoryListBoxRow* row;
};

struct _GitgRepositoryListBoxRowPrivate {
	GitgRepository* d_repository;
	GDateTime* d_time;
	gboolean d_loading;
	GitgProgressBin* d_progress_bin;
	GtkLabel* d_repository_label;
	GtkLabel* d_description_label;
	GtkLabel* d_branch_label;
	GtkSpinner* d_spinner;
	GtkCheckButton* d_remove_check_button;
	GtkRevealer* d_remove_revealer;
	GtkBox* d_languages_box;
	GitgSelectionMode d_mode;
	gchar* d_dirname;
	gchar* d_branch_name;
	gboolean _selected;
};

static gint GitgRepositoryListBox_private_offset;
static gpointer gitg_repository_list_box_parent_class = NULL;
static gint GitgRepositoryListBoxRow_private_offset;
static gpointer gitg_repository_list_box_row_parent_class = NULL;

static gboolean gitg_repository_list_box_save_repository_bookmarks (GitgRepositoryListBox* self);
static void gitg_repository_list_box_copy_bookmarks_from_recent_files (GitgRepositoryListBox* self);
static void _gtk_recent_info_unref0_ (gpointer var);
static inline void _g_list_free__gtk_recent_info_unref0_ (GList* self);
static void gitg_repository_list_box_save_repository_bookmarks_timeout (GitgRepositoryListBox* self);
static gboolean gitg_repository_list_box_real_button_press_event (GtkWidget* base,
                                                           GdkEventButton* event);
static void gitg_repository_list_box_real_row_activated (GtkListBox* base,
                                                  GtkListBoxRow* row);
static void gitg_repository_list_box_update_header (GitgRepositoryListBox* self,
                                             GtkListBoxRow* row,
                                             GtkListBoxRow* before);
static gchar* gitg_repository_list_box_normalize (GitgRepositoryListBox* self,
                                           const gchar* s);
static gboolean gitg_repository_list_box_filter (GitgRepositoryListBox* self,
                                          GtkListBoxRow* row);
static gint gitg_repository_list_box_compare_widgets (GitgRepositoryListBox* self,
                                               GtkListBoxRow* a,
                                               GtkListBoxRow* b);
static GitgRepositoryListBoxRow* gitg_repository_list_box_get_row_for_repository (GitgRepositoryListBox* self,
                                                                           GitgRepository* repository);
static void gitg_repository_list_box_add_repository_to_bookmarks (GitgRepositoryListBox* self,
                                                           const gchar* uri,
                                                           GDateTime* visited);
static gboolean _gitg_repository_list_box_save_repository_bookmarks_gsource_func (gpointer self);
static void gitg_repository_list_box_connect_repository_row (GitgRepositoryListBox* self,
                                                      GitgRepositoryListBoxRow* row);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void ___lambda85_ (GitgRepositoryListBox* self);
static void ____lambda85__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void ___lambda86_ (Block25Data* _data25_);
static void ____lambda86__gitg_repository_list_box_row_request_remove (GitgRepositoryListBoxRow* _sender,
                                                                gpointer self);
static void _vala_array_add14 (GitgRepositoryListBoxRow** * array,
                        gint* length,
                        gint* size,
                        GitgRepositoryListBoxRow* value);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void gitg_repository_list_box_row_update_branch_label (GitgRepositoryListBoxRow* self);
static void gitg_repository_list_box_row_update_repository_data (GitgRepositoryListBoxRow* self);
static void _vala_GgitOId_free (GgitOId* self);
static GObject * gitg_repository_list_box_row_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static void gitg_repository_list_box_row_finalize (GObject * obj);
static GType gitg_repository_list_box_row_get_type_once (void);
static void _vala_gitg_repository_list_box_row_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_gitg_repository_list_box_row_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static GObject * gitg_repository_list_box_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _gitg_repository_list_box_update_header_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                              GtkListBoxRow* before,
                                                                              gpointer self);
static gboolean _gitg_repository_list_box_filter_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                    gpointer self);
static gint _gitg_repository_list_box_compare_widgets_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                       GtkListBoxRow* row2,
                                                                       gpointer self);
static void gitg_repository_list_box_finalize (GObject * obj);
static GType gitg_repository_list_box_get_type_once (void);
static void _vala_gitg_repository_list_box_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_gitg_repository_list_box_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

 G_GNUC_NO_INLINE static GType
gitg_selection_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GITG_SELECTION_MODE_NORMAL, "GITG_SELECTION_MODE_NORMAL", "normal"}, {GITG_SELECTION_MODE_SELECTION, "GITG_SELECTION_MODE_SELECTION", "selection"}, {0, NULL, NULL}};
	GType gitg_selection_mode_type_id;
	gitg_selection_mode_type_id = g_enum_register_static ("GitgSelectionMode", values);
	return gitg_selection_mode_type_id;
}

GType
gitg_selection_mode_get_type (void)
{
	static gsize gitg_selection_mode_type_id__once = 0;
	if (g_once_init_enter (&gitg_selection_mode_type_id__once)) {
		GType gitg_selection_mode_type_id;
		gitg_selection_mode_type_id = gitg_selection_mode_get_type_once ();
		g_once_init_leave (&gitg_selection_mode_type_id__once, gitg_selection_mode_type_id);
	}
	return gitg_selection_mode_type_id__once;
}

static inline gpointer
gitg_repository_list_box_get_instance_private (GitgRepositoryListBox* self)
{
	return G_STRUCT_MEMBER_P (self, GitgRepositoryListBox_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 307 "../libgitg/gitg-repository-list-box.vala"
	return self ? g_object_ref (self) : NULL;
#line 249 "gitg-repository-list-box.c"
}

static gpointer
_gtk_recent_info_ref0 (gpointer self)
{
#line 310 "../libgitg/gitg-repository-list-box.vala"
	return self ? gtk_recent_info_ref (self) : NULL;
#line 257 "gitg-repository-list-box.c"
}

static void
_gtk_recent_info_unref0_ (gpointer var)
{
#line 326 "../libgitg/gitg-repository-list-box.vala"
	(var == NULL) ? NULL : (var = (gtk_recent_info_unref (var), NULL));
#line 265 "gitg-repository-list-box.c"
}

static inline void
_g_list_free__gtk_recent_info_unref0_ (GList* self)
{
#line 326 "../libgitg/gitg-repository-list-box.vala"
	g_list_free_full (self, (GDestroyNotify) _gtk_recent_info_unref0_);
#line 273 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_copy_bookmarks_from_recent_files (GitgRepositoryListBox* self)
{
	GtkRecentManager* manager = NULL;
	GtkRecentManager* _tmp0_;
	GtkRecentManager* _tmp1_;
	GList* items = NULL;
	GtkRecentManager* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 305 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 307 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = gtk_recent_manager_get_default ();
#line 307 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 307 "../libgitg/gitg-repository-list-box.vala"
	manager = _tmp1_;
#line 308 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = manager;
#line 308 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = gtk_recent_manager_get_items (_tmp2_);
#line 308 "../libgitg/gitg-repository-list-box.vala"
	items = _tmp3_;
#line 310 "../libgitg/gitg-repository-list-box.vala"
	_tmp4_ = items;
#line 303 "gitg-repository-list-box.c"
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
#line 310 "../libgitg/gitg-repository-list-box.vala"
		item_collection = _tmp4_;
#line 310 "../libgitg/gitg-repository-list-box.vala"
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 311 "gitg-repository-list-box.c"
			GtkRecentInfo* _tmp5_;
			GtkRecentInfo* item = NULL;
#line 310 "../libgitg/gitg-repository-list-box.vala"
			_tmp5_ = _gtk_recent_info_ref0 ((GtkRecentInfo*) item_it->data);
#line 310 "../libgitg/gitg-repository-list-box.vala"
			item = _tmp5_;
#line 318 "gitg-repository-list-box.c"
			{
				GtkRecentInfo* _tmp6_;
				gchar* uri = NULL;
				GtkRecentInfo* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				GBookmarkFile* _tmp10_;
				const gchar* _tmp11_;
				GtkRecentInfo* _tmp12_;
				const gchar* _tmp13_;
				GBookmarkFile* _tmp14_;
				const gchar* _tmp15_;
				GtkRecentInfo* _tmp16_;
				gsize _tmp17_ = 0;
				gchar** _tmp18_;
				gchar** _tmp19_;
				gint _tmp19__length1;
				GBookmarkFile* _tmp20_;
				const gchar* _tmp21_;
				GtkRecentInfo* _tmp22_;
				gchar* app_name = NULL;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* app_exec = NULL;
				const gchar* _tmp25_;
				gchar* _tmp26_;
#line 312 "../libgitg/gitg-repository-list-box.vala"
				_tmp6_ = item;
#line 312 "../libgitg/gitg-repository-list-box.vala"
				if (!gtk_recent_info_has_group (_tmp6_, "gitg")) {
#line 314 "../libgitg/gitg-repository-list-box.vala"
					_gtk_recent_info_unref0 (item);
#line 314 "../libgitg/gitg-repository-list-box.vala"
					continue;
#line 353 "gitg-repository-list-box.c"
				}
#line 317 "../libgitg/gitg-repository-list-box.vala"
				_tmp7_ = item;
#line 317 "../libgitg/gitg-repository-list-box.vala"
				_tmp8_ = gtk_recent_info_get_uri (_tmp7_);
#line 317 "../libgitg/gitg-repository-list-box.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 317 "../libgitg/gitg-repository-list-box.vala"
				uri = _tmp9_;
#line 319 "../libgitg/gitg-repository-list-box.vala"
				_tmp10_ = self->priv->d_bookmark_file;
#line 319 "../libgitg/gitg-repository-list-box.vala"
				_tmp11_ = uri;
#line 319 "../libgitg/gitg-repository-list-box.vala"
				_tmp12_ = item;
#line 319 "../libgitg/gitg-repository-list-box.vala"
				_tmp13_ = gtk_recent_info_get_mime_type (_tmp12_);
#line 319 "../libgitg/gitg-repository-list-box.vala"
				g_bookmark_file_set_mime_type (_tmp10_, _tmp11_, _tmp13_);
#line 320 "../libgitg/gitg-repository-list-box.vala"
				_tmp14_ = self->priv->d_bookmark_file;
#line 320 "../libgitg/gitg-repository-list-box.vala"
				_tmp15_ = uri;
#line 320 "../libgitg/gitg-repository-list-box.vala"
				_tmp16_ = item;
#line 320 "../libgitg/gitg-repository-list-box.vala"
				_tmp18_ = gtk_recent_info_get_groups (_tmp16_, &_tmp17_);
#line 320 "../libgitg/gitg-repository-list-box.vala"
				_tmp19_ = _tmp18_;
#line 320 "../libgitg/gitg-repository-list-box.vala"
				_tmp19__length1 = _tmp17_;
#line 320 "../libgitg/gitg-repository-list-box.vala"
				g_bookmark_file_set_groups (_tmp14_, _tmp15_, _tmp19_, (gint) _tmp17_);
#line 320 "../libgitg/gitg-repository-list-box.vala"
				_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 321 "../libgitg/gitg-repository-list-box.vala"
				_tmp20_ = self->priv->d_bookmark_file;
#line 321 "../libgitg/gitg-repository-list-box.vala"
				_tmp21_ = uri;
#line 321 "../libgitg/gitg-repository-list-box.vala"
				_tmp22_ = item;
#line 321 "../libgitg/gitg-repository-list-box.vala"
				g_bookmark_file_set_visited (_tmp20_, _tmp21_, (time_t) gtk_recent_info_get_modified (_tmp22_));
#line 323 "../libgitg/gitg-repository-list-box.vala"
				_tmp23_ = g_get_application_name ();
#line 323 "../libgitg/gitg-repository-list-box.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 323 "../libgitg/gitg-repository-list-box.vala"
				app_name = _tmp24_;
#line 324 "../libgitg/gitg-repository-list-box.vala"
				_tmp25_ = g_get_prgname ();
#line 324 "../libgitg/gitg-repository-list-box.vala"
				_tmp26_ = g_strjoin (" ", _tmp25_, "%f", NULL);
#line 324 "../libgitg/gitg-repository-list-box.vala"
				app_exec = _tmp26_;
#line 409 "gitg-repository-list-box.c"
				{
					GBookmarkFile* _tmp27_;
					const gchar* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_tmp27_ = self->priv->d_bookmark_file;
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_tmp28_ = uri;
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_tmp29_ = app_name;
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_tmp30_ = app_exec;
#line 326 "../libgitg/gitg-repository-list-box.vala"
					g_bookmark_file_set_app_info (_tmp27_, _tmp28_, _tmp29_, _tmp30_, 1, (time_t) -1, &_inner_error0_);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 427 "gitg-repository-list-box.c"
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
#line 326 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 436 "gitg-repository-list-box.c"
				}
				__finally0:
#line 326 "../libgitg/gitg-repository-list-box.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (app_exec);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (app_name);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (uri);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_gtk_recent_info_unref0 (item);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					(items == NULL) ? NULL : (items = (_g_list_free__gtk_recent_info_unref0_ (items), NULL));
#line 326 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (manager);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 326 "../libgitg/gitg-repository-list-box.vala"
					return;
#line 459 "gitg-repository-list-box.c"
				}
#line 310 "../libgitg/gitg-repository-list-box.vala"
				_g_free0 (app_exec);
#line 310 "../libgitg/gitg-repository-list-box.vala"
				_g_free0 (app_name);
#line 310 "../libgitg/gitg-repository-list-box.vala"
				_g_free0 (uri);
#line 310 "../libgitg/gitg-repository-list-box.vala"
				_gtk_recent_info_unref0 (item);
#line 469 "gitg-repository-list-box.c"
			}
		}
	}
#line 329 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_save_repository_bookmarks_timeout (self);
#line 305 "../libgitg/gitg-repository-list-box.vala"
	(items == NULL) ? NULL : (items = (_g_list_free__gtk_recent_info_unref0_ (items), NULL));
#line 305 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (manager);
#line 479 "gitg-repository-list-box.c"
}

static gboolean
gitg_repository_list_box_real_button_press_event (GtkWidget* base,
                                                  GdkEventButton* event)
{
	GitgRepositoryListBox * self;
	GdkEvent* ev = NULL;
	gboolean _tmp0_ = FALSE;
	GdkEvent* _tmp1_;
	gboolean result;
#line 332 "../libgitg/gitg-repository-list-box.vala"
	self = (GitgRepositoryListBox*) base;
#line 332 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 334 "../libgitg/gitg-repository-list-box.vala"
	ev = (GdkEvent*) event;
#line 336 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = ev;
#line 336 "../libgitg/gitg-repository-list-box.vala"
	if (gdk_event_triggers_context_menu (_tmp1_)) {
#line 501 "gitg-repository-list-box.c"
		GitgSelectionMode _tmp2_;
#line 336 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = self->priv->_mode;
#line 336 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = _tmp2_ == GITG_SELECTION_MODE_NORMAL;
#line 507 "gitg-repository-list-box.c"
	} else {
#line 336 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = FALSE;
#line 511 "gitg-repository-list-box.c"
	}
#line 336 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp0_) {
#line 515 "gitg-repository-list-box.c"
		GitgRepositoryListBoxRow* row = NULL;
		GtkListBoxRow* _tmp3_;
		GitgRepositoryListBoxRow* _tmp4_;
		GitgRepositoryListBoxRow* _tmp5_;
#line 338 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_set_mode (self, GITG_SELECTION_MODE_SELECTION);
#line 340 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = gtk_list_box_get_row_at_y ((GtkListBox*) self, (gint) event->y);
#line 340 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = _g_object_ref0 (GITG_REPOSITORY_LIST_BOX_IS_ROW (_tmp3_) ? ((GitgRepositoryListBoxRow*) _tmp3_) : NULL);
#line 340 "../libgitg/gitg-repository-list-box.vala"
		row = _tmp4_;
#line 342 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = row;
#line 342 "../libgitg/gitg-repository-list-box.vala"
		if (_tmp5_ != NULL) {
#line 532 "gitg-repository-list-box.c"
			GitgRepositoryListBoxRow* _tmp6_;
#line 344 "../libgitg/gitg-repository-list-box.vala"
			_tmp6_ = row;
#line 344 "../libgitg/gitg-repository-list-box.vala"
			gitg_repository_list_box_row_set_selected (_tmp6_, TRUE);
#line 538 "gitg-repository-list-box.c"
		}
#line 347 "../libgitg/gitg-repository-list-box.vala"
		result = TRUE;
#line 347 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (row);
#line 347 "../libgitg/gitg-repository-list-box.vala"
		return result;
#line 546 "gitg-repository-list-box.c"
	}
#line 350 "../libgitg/gitg-repository-list-box.vala"
	result = GTK_WIDGET_CLASS (gitg_repository_list_box_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_get_type (), GtkListBox), event);
#line 350 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 552 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_real_row_activated (GtkListBox* base,
                                             GtkListBoxRow* row)
{
	GitgRepositoryListBox * self;
	GitgRepositoryListBoxRow* r = NULL;
	GitgRepositoryListBoxRow* _tmp0_;
	GitgSelectionMode _tmp1_;
	GitgRepositoryListBoxRow* _tmp6_;
	GitgRepository* _tmp7_;
	GitgRepository* _tmp8_;
#line 353 "../libgitg/gitg-repository-list-box.vala"
	self = (GitgRepositoryListBox*) base;
#line 353 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (row != NULL);
#line 355 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow));
#line 355 "../libgitg/gitg-repository-list-box.vala"
	r = _tmp0_;
#line 357 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = self->priv->_mode;
#line 357 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp1_ == GITG_SELECTION_MODE_SELECTION) {
#line 578 "gitg-repository-list-box.c"
		GitgRepositoryListBoxRow* _tmp2_;
		GitgRepositoryListBoxRow* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 359 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = r;
#line 359 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = r;
#line 359 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = gitg_repository_list_box_row_get_selected (_tmp3_);
#line 359 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = _tmp4_;
#line 359 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_selected (_tmp2_, !_tmp5_);
#line 360 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (r);
#line 360 "../libgitg/gitg-repository-list-box.vala"
		return;
#line 597 "gitg-repository-list-box.c"
	}
#line 363 "../libgitg/gitg-repository-list-box.vala"
	_tmp6_ = r;
#line 363 "../libgitg/gitg-repository-list-box.vala"
	_tmp7_ = gitg_repository_list_box_row_get_repository (_tmp6_);
#line 363 "../libgitg/gitg-repository-list-box.vala"
	_tmp8_ = _tmp7_;
#line 363 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp8_ != NULL) {
#line 607 "gitg-repository-list-box.c"
		GitgRepositoryListBoxRow* _tmp9_;
		GitgRepository* _tmp10_;
		GitgRepository* _tmp11_;
#line 365 "../libgitg/gitg-repository-list-box.vala"
		_tmp9_ = r;
#line 365 "../libgitg/gitg-repository-list-box.vala"
		_tmp10_ = gitg_repository_list_box_row_get_repository (_tmp9_);
#line 365 "../libgitg/gitg-repository-list-box.vala"
		_tmp11_ = _tmp10_;
#line 365 "../libgitg/gitg-repository-list-box.vala"
		g_signal_emit (self, gitg_repository_list_box_signals[GITG_REPOSITORY_LIST_BOX_REPOSITORY_ACTIVATED_SIGNAL], 0, _tmp11_);
#line 619 "gitg-repository-list-box.c"
	}
#line 353 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (r);
#line 623 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_update_header (GitgRepositoryListBox* self,
                                        GtkListBoxRow* row,
                                        GtkListBoxRow* before)
{
	GtkSeparator* _tmp0_ = NULL;
#line 390 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 390 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (row != NULL);
#line 392 "../libgitg/gitg-repository-list-box.vala"
	if (before != NULL) {
#line 638 "gitg-repository-list-box.c"
		GtkSeparator* _tmp1_;
#line 392 "../libgitg/gitg-repository-list-box.vala"
		_tmp1_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 392 "../libgitg/gitg-repository-list-box.vala"
		g_object_ref_sink (_tmp1_);
#line 392 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp0_);
#line 392 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = _tmp1_;
#line 648 "gitg-repository-list-box.c"
	} else {
#line 392 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp0_);
#line 392 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = NULL;
#line 654 "gitg-repository-list-box.c"
	}
#line 392 "../libgitg/gitg-repository-list-box.vala"
	gtk_list_box_row_set_header (row, (GtkWidget*) _tmp0_);
#line 390 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (_tmp0_);
#line 660 "gitg-repository-list-box.c"
}

static gchar*
gitg_repository_list_box_normalize (GitgRepositoryListBox* self,
                                    const gchar* s)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 395 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 395 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 397 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_utf8_normalize (s, (gssize) -1, G_NORMALIZE_ALL);
#line 397 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = _tmp0_;
#line 397 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = g_utf8_casefold (_tmp1_, (gssize) -1);
#line 397 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = _tmp2_;
#line 397 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (_tmp1_);
#line 397 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp3_;
#line 397 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 690 "gitg-repository-list-box.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 709 "gitg-repository-list-box.c"
}

static gboolean
gitg_repository_list_box_filter (GitgRepositoryListBox* self,
                                 GtkListBoxRow* row)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean result;
#line 400 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 400 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 402 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = self->priv->d_filter_text;
#line 402 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp1_ != NULL) {
#line 727 "gitg-repository-list-box.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = gitg_repository_list_box_row_get_repository_name (G_TYPE_CHECK_INSTANCE_CAST (row, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow));
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = _tmp2_;
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = gitg_repository_list_box_normalize (self, _tmp3_);
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = _tmp4_;
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp6_ = self->priv->d_filter_text;
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp7_ = gitg_repository_list_box_normalize (self, _tmp6_);
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp8_ = _tmp7_;
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = string_contains (_tmp5_, _tmp8_);
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp8_);
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp5_);
#line 755 "gitg-repository-list-box.c"
	} else {
#line 402 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = TRUE;
#line 759 "gitg-repository-list-box.c"
	}
#line 402 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp0_;
#line 402 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 765 "gitg-repository-list-box.c"
}

static gint
gitg_repository_list_box_compare_widgets (GitgRepositoryListBox* self,
                                          GtkListBoxRow* a,
                                          GtkListBoxRow* b)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gint result;
#line 405 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 405 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 405 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 407 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = gitg_repository_list_box_row_get_time (G_TYPE_CHECK_INSTANCE_CAST (b, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow));
#line 407 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = _tmp0_;
#line 407 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = gitg_repository_list_box_row_get_time (G_TYPE_CHECK_INSTANCE_CAST (a, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow));
#line 407 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = _tmp2_;
#line 407 "../libgitg/gitg-repository-list-box.vala"
	result = g_date_time_compare (_tmp1_, _tmp3_);
#line 407 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 796 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_populate_bookmarks (GitgRepositoryListBox* self)
{
	gchar** uris = NULL;
	GBookmarkFile* _tmp0_;
	gsize _tmp1_ = 0;
	gchar** _tmp2_;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
#line 410 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 412 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_bookmark_file;
#line 412 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = g_bookmark_file_get_uris (_tmp0_, &_tmp1_);
#line 412 "../libgitg/gitg-repository-list-box.vala"
	uris = _tmp2_;
#line 412 "../libgitg/gitg-repository-list-box.vala"
	uris_length1 = _tmp1_;
#line 412 "../libgitg/gitg-repository-list-box.vala"
	_uris_size_ = uris_length1;
#line 414 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = uris;
#line 414 "../libgitg/gitg-repository-list-box.vala"
	_tmp3__length1 = uris_length1;
#line 827 "gitg-repository-list-box.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 414 "../libgitg/gitg-repository-list-box.vala"
		uri_collection = _tmp3_;
#line 414 "../libgitg/gitg-repository-list-box.vala"
		uri_collection_length1 = _tmp3__length1;
#line 414 "../libgitg/gitg-repository-list-box.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 839 "gitg-repository-list-box.c"
			gchar* _tmp4_;
			gchar* uri = NULL;
#line 414 "../libgitg/gitg-repository-list-box.vala"
			_tmp4_ = g_strdup (uri_collection[uri_it]);
#line 414 "../libgitg/gitg-repository-list-box.vala"
			uri = _tmp4_;
#line 846 "gitg-repository-list-box.c"
			{
				GFile* repo_file = NULL;
				const gchar* _tmp8_;
				GFile* _tmp9_;
				GitgRepository* repo = NULL;
				GDateTime* visited = NULL;
				GitgRepository* _tmp20_;
				GDateTime* _tmp21_;
				GitgRepositoryListBoxRow* _tmp22_;
				GitgRepositoryListBoxRow* _tmp23_;
				{
					gboolean _tmp5_ = FALSE;
					GBookmarkFile* _tmp6_;
					const gchar* _tmp7_;
#line 417 "../libgitg/gitg-repository-list-box.vala"
					_tmp6_ = self->priv->d_bookmark_file;
#line 417 "../libgitg/gitg-repository-list-box.vala"
					_tmp7_ = uri;
#line 417 "../libgitg/gitg-repository-list-box.vala"
					_tmp5_ = g_bookmark_file_has_group (_tmp6_, _tmp7_, "gitg", &_inner_error0_);
#line 417 "../libgitg/gitg-repository-list-box.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 869 "gitg-repository-list-box.c"
						goto __catch0_g_error;
					}
#line 417 "../libgitg/gitg-repository-list-box.vala"
					if (!_tmp5_) {
#line 419 "../libgitg/gitg-repository-list-box.vala"
						_g_free0 (uri);
#line 419 "../libgitg/gitg-repository-list-box.vala"
						continue;
#line 878 "gitg-repository-list-box.c"
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
#line 416 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 421 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (uri);
#line 421 "../libgitg/gitg-repository-list-box.vala"
					continue;
#line 890 "gitg-repository-list-box.c"
				}
				__finally0:
#line 416 "../libgitg/gitg-repository-list-box.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 416 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (uri);
#line 416 "../libgitg/gitg-repository-list-box.vala"
					uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 416 "../libgitg/gitg-repository-list-box.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 416 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 416 "../libgitg/gitg-repository-list-box.vala"
					return;
#line 905 "gitg-repository-list-box.c"
				}
#line 423 "../libgitg/gitg-repository-list-box.vala"
				_tmp8_ = uri;
#line 423 "../libgitg/gitg-repository-list-box.vala"
				_tmp9_ = g_file_new_for_uri (_tmp8_);
#line 423 "../libgitg/gitg-repository-list-box.vala"
				repo_file = _tmp9_;
#line 913 "gitg-repository-list-box.c"
				{
					GitgRepository* _tmp10_ = NULL;
					GFile* _tmp11_;
					GitgRepository* _tmp12_;
					GitgRepository* _tmp13_;
#line 428 "../libgitg/gitg-repository-list-box.vala"
					_tmp11_ = repo_file;
#line 428 "../libgitg/gitg-repository-list-box.vala"
					_tmp12_ = gitg_repository_new (_tmp11_, NULL, &_inner_error0_);
#line 428 "../libgitg/gitg-repository-list-box.vala"
					_tmp10_ = _tmp12_;
#line 428 "../libgitg/gitg-repository-list-box.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 927 "gitg-repository-list-box.c"
						goto __catch1_g_error;
					}
#line 428 "../libgitg/gitg-repository-list-box.vala"
					_tmp13_ = _tmp10_;
#line 428 "../libgitg/gitg-repository-list-box.vala"
					_tmp10_ = NULL;
#line 428 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (repo);
#line 428 "../libgitg/gitg-repository-list-box.vala"
					repo = _tmp13_;
#line 426 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (_tmp10_);
#line 940 "gitg-repository-list-box.c"
				}
				goto __finally1;
				__catch1_g_error:
				{
#line 426 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 947 "gitg-repository-list-box.c"
					{
						GBookmarkFile* _tmp14_;
						const gchar* _tmp15_;
#line 434 "../libgitg/gitg-repository-list-box.vala"
						_tmp14_ = self->priv->d_bookmark_file;
#line 434 "../libgitg/gitg-repository-list-box.vala"
						_tmp15_ = uri;
#line 434 "../libgitg/gitg-repository-list-box.vala"
						g_bookmark_file_remove_item (_tmp14_, _tmp15_, &_inner_error0_);
#line 434 "../libgitg/gitg-repository-list-box.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 959 "gitg-repository-list-box.c"
							goto __catch2_g_error;
						}
					}
					goto __finally2;
					__catch2_g_error:
					{
#line 432 "../libgitg/gitg-repository-list-box.vala"
						g_clear_error (&_inner_error0_);
#line 968 "gitg-repository-list-box.c"
					}
					__finally2:
#line 432 "../libgitg/gitg-repository-list-box.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 432 "../libgitg/gitg-repository-list-box.vala"
						_g_object_unref0 (repo);
#line 432 "../libgitg/gitg-repository-list-box.vala"
						_g_object_unref0 (repo_file);
#line 432 "../libgitg/gitg-repository-list-box.vala"
						_g_free0 (uri);
#line 432 "../libgitg/gitg-repository-list-box.vala"
						uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 432 "../libgitg/gitg-repository-list-box.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 432 "../libgitg/gitg-repository-list-box.vala"
						g_clear_error (&_inner_error0_);
#line 432 "../libgitg/gitg-repository-list-box.vala"
						return;
#line 987 "gitg-repository-list-box.c"
					}
#line 437 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (repo);
#line 437 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (repo_file);
#line 437 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (uri);
#line 437 "../libgitg/gitg-repository-list-box.vala"
					continue;
#line 997 "gitg-repository-list-box.c"
				}
				__finally1:
#line 426 "../libgitg/gitg-repository-list-box.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 426 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (repo);
#line 426 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (repo_file);
#line 426 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (uri);
#line 426 "../libgitg/gitg-repository-list-box.vala"
					uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 426 "../libgitg/gitg-repository-list-box.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 426 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 426 "../libgitg/gitg-repository-list-box.vala"
					return;
#line 1016 "gitg-repository-list-box.c"
				}
#line 440 "../libgitg/gitg-repository-list-box.vala"
				visited = NULL;
#line 1020 "gitg-repository-list-box.c"
				{
					time_t _tmp16_ = 0;
					GBookmarkFile* _tmp17_;
					const gchar* _tmp18_;
					GDateTime* _tmp19_;
#line 444 "../libgitg/gitg-repository-list-box.vala"
					_tmp17_ = self->priv->d_bookmark_file;
#line 444 "../libgitg/gitg-repository-list-box.vala"
					_tmp18_ = uri;
#line 444 "../libgitg/gitg-repository-list-box.vala"
					_tmp16_ = g_bookmark_file_get_visited (_tmp17_, _tmp18_, &_inner_error0_);
#line 444 "../libgitg/gitg-repository-list-box.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1034 "gitg-repository-list-box.c"
						goto __catch3_g_error;
					}
#line 444 "../libgitg/gitg-repository-list-box.vala"
					_tmp19_ = g_date_time_new_from_unix_utc ((gint64) _tmp16_);
#line 444 "../libgitg/gitg-repository-list-box.vala"
					_g_date_time_unref0 (visited);
#line 444 "../libgitg/gitg-repository-list-box.vala"
					visited = _tmp19_;
#line 1043 "gitg-repository-list-box.c"
				}
				goto __finally3;
				__catch3_g_error:
				{
#line 442 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 1050 "gitg-repository-list-box.c"
				}
				__finally3:
#line 442 "../libgitg/gitg-repository-list-box.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 442 "../libgitg/gitg-repository-list-box.vala"
					_g_date_time_unref0 (visited);
#line 442 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (repo);
#line 442 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (repo_file);
#line 442 "../libgitg/gitg-repository-list-box.vala"
					_g_free0 (uri);
#line 442 "../libgitg/gitg-repository-list-box.vala"
					uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 442 "../libgitg/gitg-repository-list-box.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 442 "../libgitg/gitg-repository-list-box.vala"
					g_clear_error (&_inner_error0_);
#line 442 "../libgitg/gitg-repository-list-box.vala"
					return;
#line 1071 "gitg-repository-list-box.c"
				}
#line 447 "../libgitg/gitg-repository-list-box.vala"
				_tmp20_ = repo;
#line 447 "../libgitg/gitg-repository-list-box.vala"
				_tmp21_ = visited;
#line 447 "../libgitg/gitg-repository-list-box.vala"
				_tmp22_ = gitg_repository_list_box_add_repository (self, _tmp20_, _tmp21_);
#line 447 "../libgitg/gitg-repository-list-box.vala"
				_tmp23_ = _tmp22_;
#line 447 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (_tmp23_);
#line 414 "../libgitg/gitg-repository-list-box.vala"
				_g_date_time_unref0 (visited);
#line 414 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (repo);
#line 414 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (repo_file);
#line 414 "../libgitg/gitg-repository-list-box.vala"
				_g_free0 (uri);
#line 1091 "gitg-repository-list-box.c"
			}
		}
	}
#line 410 "../libgitg/gitg-repository-list-box.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 1097 "gitg-repository-list-box.c"
}

static GitgRepositoryListBoxRow*
gitg_repository_list_box_get_row_for_repository (GitgRepositoryListBox* self,
                                                 GitgRepository* repository)
{
	GitgRepositoryListBoxRow* row = NULL;
	GList* _tmp0_;
	GitgRepositoryListBoxRow* result;
#line 451 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 451 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 453 "../libgitg/gitg-repository-list-box.vala"
	row = NULL;
#line 455 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 1115 "gitg-repository-list-box.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 455 "../libgitg/gitg-repository-list-box.vala"
		child_collection = _tmp0_;
#line 455 "../libgitg/gitg-repository-list-box.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1123 "gitg-repository-list-box.c"
			GtkWidget* child = NULL;
#line 455 "../libgitg/gitg-repository-list-box.vala"
			child = (GtkWidget*) child_it->data;
#line 1127 "gitg-repository-list-box.c"
			{
				GitgRepositoryListBoxRow* d = NULL;
				GtkWidget* _tmp1_;
				GitgRepositoryListBoxRow* _tmp2_;
				GitgRepositoryListBoxRow* _tmp3_;
				GitgRepository* _tmp4_;
				GitgRepository* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				gboolean _tmp10_;
#line 457 "../libgitg/gitg-repository-list-box.vala"
				_tmp1_ = child;
#line 457 "../libgitg/gitg-repository-list-box.vala"
				_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow));
#line 457 "../libgitg/gitg-repository-list-box.vala"
				d = _tmp2_;
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp3_ = d;
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp4_ = gitg_repository_list_box_row_get_repository (_tmp3_);
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp5_ = _tmp4_;
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp6_ = ggit_repository_get_location ((GgitRepository*) _tmp5_);
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp7_ = _tmp6_;
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp8_ = ggit_repository_get_location ((GgitRepository*) repository);
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp9_ = _tmp8_;
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_tmp10_ = g_file_equal (_tmp7_, _tmp9_);
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (_tmp9_);
#line 459 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (_tmp7_);
#line 459 "../libgitg/gitg-repository-list-box.vala"
				if (_tmp10_) {
#line 1168 "gitg-repository-list-box.c"
					GitgRepositoryListBoxRow* _tmp11_;
					GitgRepositoryListBoxRow* _tmp12_;
#line 461 "../libgitg/gitg-repository-list-box.vala"
					_tmp11_ = d;
#line 461 "../libgitg/gitg-repository-list-box.vala"
					_tmp12_ = _g_object_ref0 (_tmp11_);
#line 461 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (row);
#line 461 "../libgitg/gitg-repository-list-box.vala"
					row = _tmp12_;
#line 462 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (d);
#line 462 "../libgitg/gitg-repository-list-box.vala"
					break;
#line 1183 "gitg-repository-list-box.c"
				}
#line 455 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (d);
#line 1187 "gitg-repository-list-box.c"
			}
		}
#line 455 "../libgitg/gitg-repository-list-box.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1192 "gitg-repository-list-box.c"
	}
#line 466 "../libgitg/gitg-repository-list-box.vala"
	result = row;
#line 466 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 1198 "gitg-repository-list-box.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 1211 "gitg-repository-list-box.c"
}

static gboolean
gitg_repository_list_box_save_repository_bookmarks (GitgRepositoryListBox* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 469 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 471 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_save_repository_bookmarks_id = (guint) 0;
#line 473 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = gitg_repository_list_box_get_location (self);
#line 473 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = _tmp0_;
#line 473 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp1_ == NULL) {
#line 475 "../libgitg/gitg-repository-list-box.vala"
		result = FALSE;
#line 475 "../libgitg/gitg-repository-list-box.vala"
		return result;
#line 1235 "gitg-repository-list-box.c"
	}
	{
		GFile* dir = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
#line 480 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = gitg_repository_list_box_get_location (self);
#line 480 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = _tmp2_;
#line 480 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = g_file_get_parent (_tmp3_);
#line 480 "../libgitg/gitg-repository-list-box.vala"
		dir = _tmp4_;
#line 481 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = dir;
#line 481 "../libgitg/gitg-repository-list-box.vala"
		g_file_make_directory_with_parents (_tmp5_, NULL, &_inner_error0_);
#line 481 "../libgitg/gitg-repository-list-box.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (dir);
#line 1259 "gitg-repository-list-box.c"
			goto __catch0_g_error;
		}
#line 478 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (dir);
#line 1264 "gitg-repository-list-box.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 478 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 1271 "gitg-repository-list-box.c"
	}
	__finally0:
#line 478 "../libgitg/gitg-repository-list-box.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1276 "gitg-repository-list-box.c"
		gboolean _tmp6_ = FALSE;
#line 478 "../libgitg/gitg-repository-list-box.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 478 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 478 "../libgitg/gitg-repository-list-box.vala"
		return _tmp6_;
#line 1284 "gitg-repository-list-box.c"
	}
	{
		GBookmarkFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 486 "../libgitg/gitg-repository-list-box.vala"
		_tmp7_ = self->priv->d_bookmark_file;
#line 486 "../libgitg/gitg-repository-list-box.vala"
		_tmp8_ = gitg_repository_list_box_get_location (self);
#line 486 "../libgitg/gitg-repository-list-box.vala"
		_tmp9_ = _tmp8_;
#line 486 "../libgitg/gitg-repository-list-box.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 486 "../libgitg/gitg-repository-list-box.vala"
		_tmp11_ = _tmp10_;
#line 486 "../libgitg/gitg-repository-list-box.vala"
		g_bookmark_file_to_file (_tmp7_, _tmp11_, &_inner_error0_);
#line 486 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp11_);
#line 486 "../libgitg/gitg-repository-list-box.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1308 "gitg-repository-list-box.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		FILE* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 484 "../libgitg/gitg-repository-list-box.vala"
		e = _inner_error0_;
#line 484 "../libgitg/gitg-repository-list-box.vala"
		_inner_error0_ = NULL;
#line 490 "../libgitg/gitg-repository-list-box.vala"
		_tmp12_ = stderr;
#line 490 "../libgitg/gitg-repository-list-box.vala"
		_tmp13_ = e;
#line 490 "../libgitg/gitg-repository-list-box.vala"
		_tmp14_ = _tmp13_->message;
#line 490 "../libgitg/gitg-repository-list-box.vala"
		_tmp15_ = string_to_string (_tmp14_);
#line 490 "../libgitg/gitg-repository-list-box.vala"
		_tmp16_ = g_strconcat ("Failed to save repository bookmarks: ", _tmp15_, "\n", NULL);
#line 490 "../libgitg/gitg-repository-list-box.vala"
		_tmp17_ = _tmp16_;
#line 490 "../libgitg/gitg-repository-list-box.vala"
		fprintf (_tmp12_, "%s", _tmp17_);
#line 490 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp17_);
#line 484 "../libgitg/gitg-repository-list-box.vala"
		_g_error_free0 (e);
#line 1344 "gitg-repository-list-box.c"
	}
	__finally1:
#line 484 "../libgitg/gitg-repository-list-box.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1349 "gitg-repository-list-box.c"
		gboolean _tmp18_ = FALSE;
#line 484 "../libgitg/gitg-repository-list-box.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 484 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 484 "../libgitg/gitg-repository-list-box.vala"
		return _tmp18_;
#line 1357 "gitg-repository-list-box.c"
	}
#line 493 "../libgitg/gitg-repository-list-box.vala"
	result = FALSE;
#line 493 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 1363 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_add_repository_to_bookmarks (GitgRepositoryListBox* self,
                                                      const gchar* uri,
                                                      GDateTime* visited)
{
	GBookmarkFile* _tmp0_;
	GBookmarkFile* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	time_t _tmp5_ = 0;
	GBookmarkFile* _tmp6_;
	gchar* app_name = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* app_exec = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 496 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 496 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (uri != NULL);
#line 498 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_bookmark_file;
#line 498 "../libgitg/gitg-repository-list-box.vala"
	g_bookmark_file_set_mime_type (_tmp0_, uri, "inode/directory");
#line 499 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = self->priv->d_bookmark_file;
#line 499 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = g_strdup ("gitg");
#line 499 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = g_new0 (gchar*, 1 + 1);
#line 499 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_[0] = _tmp2_;
#line 499 "../libgitg/gitg-repository-list-box.vala"
	_tmp4_ = _tmp3_;
#line 499 "../libgitg/gitg-repository-list-box.vala"
	_tmp4__length1 = 1;
#line 499 "../libgitg/gitg-repository-list-box.vala"
	g_bookmark_file_set_groups (_tmp1_, uri, _tmp4_, (gint) 1);
#line 499 "../libgitg/gitg-repository-list-box.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 500 "../libgitg/gitg-repository-list-box.vala"
	if (visited == NULL) {
#line 500 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = (time_t) -1;
#line 1414 "gitg-repository-list-box.c"
	} else {
#line 500 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = (time_t) g_date_time_to_unix (visited);
#line 1418 "gitg-repository-list-box.c"
	}
#line 500 "../libgitg/gitg-repository-list-box.vala"
	_tmp6_ = self->priv->d_bookmark_file;
#line 500 "../libgitg/gitg-repository-list-box.vala"
	g_bookmark_file_set_visited (_tmp6_, uri, _tmp5_);
#line 502 "../libgitg/gitg-repository-list-box.vala"
	_tmp7_ = g_get_application_name ();
#line 502 "../libgitg/gitg-repository-list-box.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 502 "../libgitg/gitg-repository-list-box.vala"
	app_name = _tmp8_;
#line 503 "../libgitg/gitg-repository-list-box.vala"
	_tmp9_ = g_get_prgname ();
#line 503 "../libgitg/gitg-repository-list-box.vala"
	_tmp10_ = g_strjoin (" ", _tmp9_, "%f", NULL);
#line 503 "../libgitg/gitg-repository-list-box.vala"
	app_exec = _tmp10_;
#line 1436 "gitg-repository-list-box.c"
	{
		GBookmarkFile* _tmp11_;
#line 505 "../libgitg/gitg-repository-list-box.vala"
		_tmp11_ = self->priv->d_bookmark_file;
#line 505 "../libgitg/gitg-repository-list-box.vala"
		g_bookmark_file_set_app_info (_tmp11_, uri, app_name, app_exec, 1, (time_t) -1, &_inner_error0_);
#line 505 "../libgitg/gitg-repository-list-box.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1445 "gitg-repository-list-box.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 505 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 1454 "gitg-repository-list-box.c"
	}
	__finally0:
#line 505 "../libgitg/gitg-repository-list-box.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 505 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (app_exec);
#line 505 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (app_name);
#line 505 "../libgitg/gitg-repository-list-box.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 505 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 505 "../libgitg/gitg-repository-list-box.vala"
		return;
#line 1469 "gitg-repository-list-box.c"
	}
#line 507 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_save_repository_bookmarks_timeout (self);
#line 496 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (app_exec);
#line 496 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (app_name);
#line 1477 "gitg-repository-list-box.c"
}

static gboolean
_gitg_repository_list_box_save_repository_bookmarks_gsource_func (gpointer self)
{
	gboolean result;
	result = gitg_repository_list_box_save_repository_bookmarks ((GitgRepositoryListBox*) self);
#line 517 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 1487 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_save_repository_bookmarks_timeout (GitgRepositoryListBox* self)
{
#line 510 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 512 "../libgitg/gitg-repository-list-box.vala"
	if (self->priv->d_save_repository_bookmarks_id != ((guint) 0)) {
#line 514 "../libgitg/gitg-repository-list-box.vala"
		return;
#line 1499 "gitg-repository-list-box.c"
	}
#line 517 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_save_repository_bookmarks_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, _gitg_repository_list_box_save_repository_bookmarks_gsource_func, g_object_ref (self), g_object_unref);
#line 1503 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_end_cloning (GitgRepositoryListBox* self,
                                      GitgRepositoryListBoxRow* row,
                                      GitgRepository* repository)
{
#line 520 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 520 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (row != NULL);
#line 522 "../libgitg/gitg-repository-list-box.vala"
	if (repository != NULL) {
#line 1517 "gitg-repository-list-box.c"
		GFile* workdir = NULL;
		GFile* _tmp0_;
		GFile* repo_file = NULL;
		GFile* _tmp1_;
		gchar* _tmp2_ = NULL;
		GFile* _tmp3_;
		gchar* uri = NULL;
		gchar* _tmp8_;
		const gchar* _tmp9_;
#line 524 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = ggit_repository_get_workdir ((GgitRepository*) repository);
#line 524 "../libgitg/gitg-repository-list-box.vala"
		workdir = _tmp0_;
#line 525 "../libgitg/gitg-repository-list-box.vala"
		_tmp1_ = ggit_repository_get_location ((GgitRepository*) repository);
#line 525 "../libgitg/gitg-repository-list-box.vala"
		repo_file = _tmp1_;
#line 527 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = workdir;
#line 527 "../libgitg/gitg-repository-list-box.vala"
		if (_tmp3_ != NULL) {
#line 1539 "gitg-repository-list-box.c"
			GFile* _tmp4_;
			gchar* _tmp5_;
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_tmp4_ = workdir;
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_tmp5_ = g_file_get_uri (_tmp4_);
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_g_free0 (_tmp2_);
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_tmp2_ = _tmp5_;
#line 1550 "gitg-repository-list-box.c"
		} else {
			GFile* _tmp6_;
			gchar* _tmp7_;
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_tmp6_ = repo_file;
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_tmp7_ = g_file_get_uri (_tmp6_);
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_g_free0 (_tmp2_);
#line 527 "../libgitg/gitg-repository-list-box.vala"
			_tmp2_ = _tmp7_;
#line 1562 "gitg-repository-list-box.c"
		}
#line 527 "../libgitg/gitg-repository-list-box.vala"
		_tmp8_ = g_strdup (_tmp2_);
#line 527 "../libgitg/gitg-repository-list-box.vala"
		uri = _tmp8_;
#line 528 "../libgitg/gitg-repository-list-box.vala"
		_tmp9_ = uri;
#line 528 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_add_repository_to_bookmarks (self, _tmp9_, NULL);
#line 530 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_repository (row, repository);
#line 531 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_loading (row, FALSE);
#line 533 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_connect_repository_row (self, row);
#line 522 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (uri);
#line 522 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp2_);
#line 522 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (repo_file);
#line 522 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (workdir);
#line 1586 "gitg-repository-list-box.c"
	} else {
#line 537 "../libgitg/gitg-repository-list-box.vala"
		gtk_container_remove ((GtkContainer*) self, (GtkWidget*) row);
#line 1590 "gitg-repository-list-box.c"
	}
}

GitgRepositoryListBoxRow*
gitg_repository_list_box_begin_cloning (GitgRepositoryListBox* self,
                                        GFile* location)
{
	GitgRepositoryListBoxRow* row = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GitgRepositoryListBoxRow* _tmp4_;
	GitgRepositoryListBoxRow* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GitgRepositoryListBoxRow* result;
#line 541 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 541 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (location != NULL, NULL);
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_file_get_parent (location);
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = _tmp0_;
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = gitg_utils_replace_home_dir_with_tilde (_tmp1_);
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = _tmp2_;
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_tmp4_ = gitg_repository_list_box_row_new (NULL, _tmp3_);
#line 543 "../libgitg/gitg-repository-list-box.vala"
	g_object_ref_sink (_tmp4_);
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_tmp5_ = _tmp4_;
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (_tmp3_);
#line 543 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (_tmp1_);
#line 543 "../libgitg/gitg-repository-list-box.vala"
	row = _tmp5_;
#line 544 "../libgitg/gitg-repository-list-box.vala"
	_tmp6_ = g_file_get_basename (location);
#line 544 "../libgitg/gitg-repository-list-box.vala"
	_tmp7_ = _tmp6_;
#line 544 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_set_repository_name (row, _tmp7_);
#line 544 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (_tmp7_);
#line 545 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_set_branch_name (row, _ ("Cloning…"));
#line 547 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_set_loading (row, TRUE);
#line 548 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_show ((GtkWidget*) row);
#line 550 "../libgitg/gitg-repository-list-box.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) row);
#line 551 "../libgitg/gitg-repository-list-box.vala"
	result = row;
#line 551 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 1652 "gitg-repository-list-box.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 554 "../libgitg/gitg-repository-list-box.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	return _data25_;
#line 1662 "gitg-repository-list-box.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 554 "../libgitg/gitg-repository-list-box.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 1672 "gitg-repository-list-box.c"
		GitgRepositoryListBox* self;
#line 554 "../libgitg/gitg-repository-list-box.vala"
		self = _data25_->self;
#line 554 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_data25_->workdir);
#line 554 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_data25_->row);
#line 554 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (self);
#line 554 "../libgitg/gitg-repository-list-box.vala"
		g_slice_free (Block25Data, _data25_);
#line 1684 "gitg-repository-list-box.c"
	}
}

static void
___lambda85_ (GitgRepositoryListBox* self)
{
#line 564 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify ((GObject*) self, "has-selection");
#line 1693 "gitg-repository-list-box.c"
}

static void
____lambda85__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 563 "../libgitg/gitg-repository-list-box.vala"
	___lambda85_ ((GitgRepositoryListBox*) self);
#line 1703 "gitg-repository-list-box.c"
}

static void
___lambda86_ (Block25Data* _data25_)
{
	GitgRepositoryListBox* self;
	GError* _inner_error0_ = NULL;
#line 567 "../libgitg/gitg-repository-list-box.vala"
	self = _data25_->self;
#line 1713 "gitg-repository-list-box.c"
	{
		GBookmarkFile* _tmp0_;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 570 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = self->priv->d_bookmark_file;
#line 570 "../libgitg/gitg-repository-list-box.vala"
		_tmp1_ = _data25_->workdir;
#line 570 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = g_file_get_uri (_tmp1_);
#line 570 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = _tmp2_;
#line 570 "../libgitg/gitg-repository-list-box.vala"
		g_bookmark_file_remove_item (_tmp0_, _tmp3_, &_inner_error0_);
#line 570 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp3_);
#line 570 "../libgitg/gitg-repository-list-box.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1733 "gitg-repository-list-box.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 568 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 1742 "gitg-repository-list-box.c"
	}
	__finally0:
#line 568 "../libgitg/gitg-repository-list-box.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 568 "../libgitg/gitg-repository-list-box.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 568 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 568 "../libgitg/gitg-repository-list-box.vala"
		return;
#line 1753 "gitg-repository-list-box.c"
	}
#line 573 "../libgitg/gitg-repository-list-box.vala"
	gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _data25_->row);
#line 1757 "gitg-repository-list-box.c"
}

static void
____lambda86__gitg_repository_list_box_row_request_remove (GitgRepositoryListBoxRow* _sender,
                                                           gpointer self)
{
#line 567 "../libgitg/gitg-repository-list-box.vala"
	___lambda86_ (self);
#line 1766 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_connect_repository_row (GitgRepositoryListBox* self,
                                                 GitgRepositoryListBoxRow* row)
{
	Block25Data* _data25_;
	GitgRepositoryListBoxRow* _tmp0_;
	GitgRepository* repository = NULL;
	GitgRepository* _tmp1_;
	GitgRepository* _tmp2_;
	GitgRepository* _tmp3_;
	GFile* _tmp4_ = NULL;
	GitgRepository* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gboolean _tmp9_;
	GFile* _tmp16_;
	GFile* _tmp17_;
#line 554 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (row != NULL);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_data25_->_ref_count_ = 1;
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_data25_->self = g_object_ref (self);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = _g_object_ref0 (row);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (_data25_->row);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_data25_->row = _tmp0_;
#line 556 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = gitg_repository_list_box_row_get_repository (_data25_->row);
#line 556 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = _tmp1_;
#line 556 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 556 "../libgitg/gitg-repository-list-box.vala"
	repository = _tmp3_;
#line 557 "../libgitg/gitg-repository-list-box.vala"
	_tmp5_ = repository;
#line 557 "../libgitg/gitg-repository-list-box.vala"
	g_object_get ((GgitRepository*) _tmp5_, "workdir", &_tmp6_, NULL);
#line 557 "../libgitg/gitg-repository-list-box.vala"
	_tmp7_ = _tmp6_;
#line 557 "../libgitg/gitg-repository-list-box.vala"
	_tmp8_ = _tmp7_;
#line 557 "../libgitg/gitg-repository-list-box.vala"
	_tmp9_ = _tmp8_ != NULL;
#line 557 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (_tmp8_);
#line 557 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp9_) {
#line 1825 "gitg-repository-list-box.c"
		GitgRepository* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_tmp10_ = repository;
#line 557 "../libgitg/gitg-repository-list-box.vala"
		g_object_get ((GgitRepository*) _tmp10_, "workdir", &_tmp11_, NULL);
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_tmp12_ = _tmp11_;
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp4_);
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = _tmp12_;
#line 1839 "gitg-repository-list-box.c"
	} else {
		GitgRepository* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_tmp13_ = repository;
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_tmp14_ = ggit_repository_get_location ((GgitRepository*) _tmp13_);
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_tmp15_ = _tmp14_;
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp4_);
#line 557 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = _tmp15_;
#line 1854 "gitg-repository-list-box.c"
	}
#line 557 "../libgitg/gitg-repository-list-box.vala"
	_tmp16_ = _g_object_ref0 (_tmp4_);
#line 557 "../libgitg/gitg-repository-list-box.vala"
	_data25_->workdir = _tmp16_;
#line 559 "../libgitg/gitg-repository-list-box.vala"
	_tmp17_ = _data25_->workdir;
#line 559 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp17_ != NULL) {
#line 561 "../libgitg/gitg-repository-list-box.vala"
		g_object_bind_property_with_closures ((GObject*) self, "mode", (GObject*) _data25_->row, "mode", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 563 "../libgitg/gitg-repository-list-box.vala"
		g_signal_connect_object ((GObject*) _data25_->row, "notify::selected", (GCallback) ____lambda85__g_object_notify, self, 0);
#line 567 "../libgitg/gitg-repository-list-box.vala"
		g_signal_connect_data (_data25_->row, "request-remove", (GCallback) ____lambda86__gitg_repository_list_box_row_request_remove, block25_data_ref (_data25_), (GClosureNotify) block25_data_unref, 0);
#line 576 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_can_remove (_data25_->row, TRUE);
#line 1872 "gitg-repository-list-box.c"
	} else {
#line 580 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_can_remove (_data25_->row, FALSE);
#line 1876 "gitg-repository-list-box.c"
	}
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (_tmp4_);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (repository);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	block25_data_unref (_data25_);
#line 554 "../libgitg/gitg-repository-list-box.vala"
	_data25_ = NULL;
#line 1886 "gitg-repository-list-box.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 602 "../libgitg/gitg-repository-list-box.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 1894 "gitg-repository-list-box.c"
}

GitgRepositoryListBoxRow*
gitg_repository_list_box_add_repository (GitgRepositoryListBox* self,
                                         GitgRepository* repository,
                                         GDateTime* visited)
{
	GitgRepositoryListBoxRow* row = NULL;
	GitgRepositoryListBoxRow* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_;
	GFile* f = NULL;
	GFile* _tmp10_;
	GitgRepositoryListBoxRow* _tmp11_;
	GDateTime* _tmp30_ = NULL;
	GitgRepositoryListBoxRow* _tmp33_;
	GFile* _tmp34_;
	GitgRepositoryListBoxRow* result;
#line 585 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 585 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 587 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = gitg_repository_list_box_get_row_for_repository (self, repository);
#line 587 "../libgitg/gitg-repository-list-box.vala"
	row = _tmp0_;
#line 589 "../libgitg/gitg-repository-list-box.vala"
	g_object_get ((GgitRepository*) repository, "workdir", &_tmp2_, NULL);
#line 589 "../libgitg/gitg-repository-list-box.vala"
	_tmp3_ = _tmp2_;
#line 589 "../libgitg/gitg-repository-list-box.vala"
	_tmp4_ = _tmp3_;
#line 589 "../libgitg/gitg-repository-list-box.vala"
	_tmp5_ = _tmp4_ != NULL;
#line 589 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (_tmp4_);
#line 589 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp5_) {
#line 1936 "gitg-repository-list-box.c"
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 589 "../libgitg/gitg-repository-list-box.vala"
		g_object_get ((GgitRepository*) repository, "workdir", &_tmp6_, NULL);
#line 589 "../libgitg/gitg-repository-list-box.vala"
		_tmp7_ = _tmp6_;
#line 589 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp1_);
#line 589 "../libgitg/gitg-repository-list-box.vala"
		_tmp1_ = _tmp7_;
#line 1947 "gitg-repository-list-box.c"
	} else {
		GFile* _tmp8_;
		GFile* _tmp9_;
#line 589 "../libgitg/gitg-repository-list-box.vala"
		_tmp8_ = ggit_repository_get_location ((GgitRepository*) repository);
#line 589 "../libgitg/gitg-repository-list-box.vala"
		_tmp9_ = _tmp8_;
#line 589 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp1_);
#line 589 "../libgitg/gitg-repository-list-box.vala"
		_tmp1_ = _tmp9_;
#line 1959 "gitg-repository-list-box.c"
	}
#line 589 "../libgitg/gitg-repository-list-box.vala"
	_tmp10_ = _g_object_ref0 (_tmp1_);
#line 589 "../libgitg/gitg-repository-list-box.vala"
	f = _tmp10_;
#line 591 "../libgitg/gitg-repository-list-box.vala"
	_tmp11_ = row;
#line 591 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp11_ == NULL) {
#line 1969 "gitg-repository-list-box.c"
		GFile* _tmp12_ = NULL;
		GFile* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		gboolean _tmp16_;
		gchar* dirname = NULL;
		GFile* _tmp21_;
		GFile* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		GitgRepositoryListBoxRow* _tmp26_;
		GitgRepositoryListBoxRow* _tmp27_;
		GitgRepositoryListBoxRow* _tmp28_;
		GitgRepositoryListBoxRow* _tmp29_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
		g_object_get ((GgitRepository*) repository, "workdir", &_tmp13_, NULL);
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_tmp14_ = _tmp13_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_tmp15_ = _tmp14_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_tmp16_ = _tmp15_ != NULL;
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp15_);
#line 593 "../libgitg/gitg-repository-list-box.vala"
		if (_tmp16_) {
#line 1997 "gitg-repository-list-box.c"
			GFile* _tmp17_;
			GFile* _tmp18_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
			g_object_get ((GgitRepository*) repository, "workdir", &_tmp17_, NULL);
#line 593 "../libgitg/gitg-repository-list-box.vala"
			_tmp18_ = _tmp17_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (_tmp12_);
#line 593 "../libgitg/gitg-repository-list-box.vala"
			_tmp12_ = _tmp18_;
#line 2008 "gitg-repository-list-box.c"
		} else {
			GFile* _tmp19_;
			GFile* _tmp20_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
			_tmp19_ = ggit_repository_get_location ((GgitRepository*) repository);
#line 593 "../libgitg/gitg-repository-list-box.vala"
			_tmp20_ = _tmp19_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (_tmp12_);
#line 593 "../libgitg/gitg-repository-list-box.vala"
			_tmp12_ = _tmp20_;
#line 2020 "gitg-repository-list-box.c"
		}
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_tmp21_ = g_file_get_parent (_tmp12_);
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_tmp22_ = _tmp21_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_tmp23_ = gitg_utils_replace_home_dir_with_tilde (_tmp22_);
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_tmp24_ = _tmp23_;
#line 593 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp22_);
#line 593 "../libgitg/gitg-repository-list-box.vala"
		dirname = _tmp24_;
#line 594 "../libgitg/gitg-repository-list-box.vala"
		_tmp25_ = dirname;
#line 594 "../libgitg/gitg-repository-list-box.vala"
		_tmp26_ = gitg_repository_list_box_row_new (repository, _tmp25_);
#line 594 "../libgitg/gitg-repository-list-box.vala"
		g_object_ref_sink (_tmp26_);
#line 594 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (row);
#line 594 "../libgitg/gitg-repository-list-box.vala"
		row = _tmp26_;
#line 595 "../libgitg/gitg-repository-list-box.vala"
		_tmp27_ = row;
#line 595 "../libgitg/gitg-repository-list-box.vala"
		gtk_widget_show ((GtkWidget*) _tmp27_);
#line 597 "../libgitg/gitg-repository-list-box.vala"
		_tmp28_ = row;
#line 597 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_connect_repository_row (self, _tmp28_);
#line 599 "../libgitg/gitg-repository-list-box.vala"
		_tmp29_ = row;
#line 599 "../libgitg/gitg-repository-list-box.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp29_);
#line 591 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (dirname);
#line 591 "../libgitg/gitg-repository-list-box.vala"
		_g_object_unref0 (_tmp12_);
#line 2060 "gitg-repository-list-box.c"
	}
#line 602 "../libgitg/gitg-repository-list-box.vala"
	if (visited != NULL) {
#line 2064 "gitg-repository-list-box.c"
		GDateTime* _tmp31_;
#line 602 "../libgitg/gitg-repository-list-box.vala"
		_tmp31_ = _g_date_time_ref0 (visited);
#line 602 "../libgitg/gitg-repository-list-box.vala"
		_g_date_time_unref0 (_tmp30_);
#line 602 "../libgitg/gitg-repository-list-box.vala"
		_tmp30_ = _tmp31_;
#line 2072 "gitg-repository-list-box.c"
	} else {
		GDateTime* _tmp32_;
#line 602 "../libgitg/gitg-repository-list-box.vala"
		_tmp32_ = g_date_time_new_now_local ();
#line 602 "../libgitg/gitg-repository-list-box.vala"
		_g_date_time_unref0 (_tmp30_);
#line 602 "../libgitg/gitg-repository-list-box.vala"
		_tmp30_ = _tmp32_;
#line 2081 "gitg-repository-list-box.c"
	}
#line 602 "../libgitg/gitg-repository-list-box.vala"
	_tmp33_ = row;
#line 602 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_set_time (_tmp33_, _tmp30_);
#line 603 "../libgitg/gitg-repository-list-box.vala"
	gtk_list_box_invalidate_sort ((GtkListBox*) self);
#line 605 "../libgitg/gitg-repository-list-box.vala"
	_tmp34_ = f;
#line 605 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp34_ != NULL) {
#line 2093 "gitg-repository-list-box.c"
		GFile* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 607 "../libgitg/gitg-repository-list-box.vala"
		_tmp35_ = f;
#line 607 "../libgitg/gitg-repository-list-box.vala"
		_tmp36_ = g_file_get_uri (_tmp35_);
#line 607 "../libgitg/gitg-repository-list-box.vala"
		_tmp37_ = _tmp36_;
#line 607 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_add_repository_to_bookmarks (self, _tmp37_, visited);
#line 607 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp37_);
#line 2107 "gitg-repository-list-box.c"
	}
#line 610 "../libgitg/gitg-repository-list-box.vala"
	result = row;
#line 610 "../libgitg/gitg-repository-list-box.vala"
	_g_date_time_unref0 (_tmp30_);
#line 610 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (f);
#line 610 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (_tmp1_);
#line 610 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 2119 "gitg-repository-list-box.c"
}

static void
_vala_array_add14 (GitgRepositoryListBoxRow** * array,
                   gint* length,
                   gint* size,
                   GitgRepositoryListBoxRow* value)
{
#line 623 "../libgitg/gitg-repository-list-box.vala"
	if ((*length) == (*size)) {
#line 623 "../libgitg/gitg-repository-list-box.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 623 "../libgitg/gitg-repository-list-box.vala"
		*array = g_renew (GitgRepositoryListBoxRow*, *array, (*size) + 1);
#line 2134 "gitg-repository-list-box.c"
	}
#line 623 "../libgitg/gitg-repository-list-box.vala"
	(*array)[(*length)++] = value;
#line 623 "../libgitg/gitg-repository-list-box.vala"
	(*array)[*length] = NULL;
#line 2140 "gitg-repository-list-box.c"
}

GitgRepositoryListBoxRow**
gitg_repository_list_box_get_selection (GitgRepositoryListBox* self,
                                        gint* result_length1)
{
	GitgRepositoryListBoxRow** ret = NULL;
	GitgRepositoryListBoxRow** _tmp0_;
	gint ret_length1;
	gint _ret_size_;
	GList* _tmp1_;
	GitgRepositoryListBoxRow** _tmp9_;
	gint _tmp9__length1;
	GitgRepositoryListBoxRow** result;
#line 613 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 615 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_new0 (GitgRepositoryListBoxRow*, 0 + 1);
#line 615 "../libgitg/gitg-repository-list-box.vala"
	ret = _tmp0_;
#line 615 "../libgitg/gitg-repository-list-box.vala"
	ret_length1 = 0;
#line 615 "../libgitg/gitg-repository-list-box.vala"
	_ret_size_ = ret_length1;
#line 617 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) self);
#line 2167 "gitg-repository-list-box.c"
	{
		GList* row_collection = NULL;
		GList* row_it = NULL;
#line 617 "../libgitg/gitg-repository-list-box.vala"
		row_collection = _tmp1_;
#line 617 "../libgitg/gitg-repository-list-box.vala"
		for (row_it = row_collection; row_it != NULL; row_it = row_it->next) {
#line 2175 "gitg-repository-list-box.c"
			GtkWidget* row = NULL;
#line 617 "../libgitg/gitg-repository-list-box.vala"
			row = (GtkWidget*) row_it->data;
#line 2179 "gitg-repository-list-box.c"
			{
				GitgRepositoryListBoxRow* r = NULL;
				GtkWidget* _tmp2_;
				GitgRepositoryListBoxRow* _tmp3_;
				GitgRepositoryListBoxRow* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
#line 619 "../libgitg/gitg-repository-list-box.vala"
				_tmp2_ = row;
#line 619 "../libgitg/gitg-repository-list-box.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow));
#line 619 "../libgitg/gitg-repository-list-box.vala"
				r = _tmp3_;
#line 621 "../libgitg/gitg-repository-list-box.vala"
				_tmp4_ = r;
#line 621 "../libgitg/gitg-repository-list-box.vala"
				_tmp5_ = gitg_repository_list_box_row_get_selected (_tmp4_);
#line 621 "../libgitg/gitg-repository-list-box.vala"
				_tmp6_ = _tmp5_;
#line 621 "../libgitg/gitg-repository-list-box.vala"
				if (_tmp6_) {
#line 2201 "gitg-repository-list-box.c"
					GitgRepositoryListBoxRow* _tmp7_;
					GitgRepositoryListBoxRow* _tmp8_;
#line 623 "../libgitg/gitg-repository-list-box.vala"
					_tmp7_ = r;
#line 623 "../libgitg/gitg-repository-list-box.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 623 "../libgitg/gitg-repository-list-box.vala"
					_vala_array_add14 (&ret, &ret_length1, &_ret_size_, _tmp8_);
#line 2210 "gitg-repository-list-box.c"
				}
#line 617 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (r);
#line 2214 "gitg-repository-list-box.c"
			}
		}
#line 617 "../libgitg/gitg-repository-list-box.vala"
		(row_collection == NULL) ? NULL : (row_collection = (g_list_free (row_collection), NULL));
#line 2219 "gitg-repository-list-box.c"
	}
#line 627 "../libgitg/gitg-repository-list-box.vala"
	_tmp9_ = ret;
#line 627 "../libgitg/gitg-repository-list-box.vala"
	_tmp9__length1 = ret_length1;
#line 627 "../libgitg/gitg-repository-list-box.vala"
	if (result_length1) {
#line 627 "../libgitg/gitg-repository-list-box.vala"
		*result_length1 = _tmp9__length1;
#line 2229 "gitg-repository-list-box.c"
	}
#line 627 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp9_;
#line 627 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 2235 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_filter_text (GitgRepositoryListBox* self,
                                      const gchar* text)
{
	gchar* _tmp0_;
#line 648 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 650 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_strdup (text);
#line 650 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (self->priv->d_filter_text);
#line 650 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_filter_text = _tmp0_;
#line 652 "../libgitg/gitg-repository-list-box.vala"
	gtk_list_box_invalidate_filter ((GtkListBox*) self);
#line 2253 "gitg-repository-list-box.c"
}

GitgRepositoryListBox*
gitg_repository_list_box_construct (GType object_type)
{
	GitgRepositoryListBox * self = NULL;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	self = (GitgRepositoryListBox*) g_object_new (object_type, NULL);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	return self;
#line 2264 "gitg-repository-list-box.c"
}

GitgRepositoryListBox*
gitg_repository_list_box_new (void)
{
#line 28 "../libgitg/gitg-repository-list-box.vala"
	return gitg_repository_list_box_construct (GITG_TYPE_REPOSITORY_LIST_BOX);
#line 2272 "gitg-repository-list-box.c"
}

GitgSelectionMode
gitg_repository_list_box_get_mode (GitgRepositoryListBox* self)
{
	GitgSelectionMode result;
#line 260 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 260 "../libgitg/gitg-repository-list-box.vala"
	result = self->priv->_mode;
#line 260 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 2285 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_set_mode (GitgRepositoryListBox* self,
                                   GitgSelectionMode value)
{
	GitgSelectionMode old_value;
#line 260 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 260 "../libgitg/gitg-repository-list-box.vala"
	old_value = gitg_repository_list_box_get_mode (self);
#line 260 "../libgitg/gitg-repository-list-box.vala"
	if (old_value != value) {
#line 260 "../libgitg/gitg-repository-list-box.vala"
		self->priv->_mode = value;
#line 260 "../libgitg/gitg-repository-list-box.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_MODE_PROPERTY]);
#line 2303 "gitg-repository-list-box.c"
	}
}

gboolean
gitg_repository_list_box_get_bookmarks_from_recent_files (GitgRepositoryListBox* self)
{
	gboolean result;
#line 262 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 262 "../libgitg/gitg-repository-list-box.vala"
	result = self->priv->_bookmarks_from_recent_files;
#line 262 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 2317 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_set_bookmarks_from_recent_files (GitgRepositoryListBox* self,
                                                          gboolean value)
{
	gboolean old_value;
#line 262 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 262 "../libgitg/gitg-repository-list-box.vala"
	old_value = gitg_repository_list_box_get_bookmarks_from_recent_files (self);
#line 262 "../libgitg/gitg-repository-list-box.vala"
	if (old_value != value) {
#line 262 "../libgitg/gitg-repository-list-box.vala"
		self->priv->_bookmarks_from_recent_files = value;
#line 262 "../libgitg/gitg-repository-list-box.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_BOOKMARKS_FROM_RECENT_FILES_PROPERTY]);
#line 2335 "gitg-repository-list-box.c"
	}
}

GFile*
gitg_repository_list_box_get_location (GitgRepositoryListBox* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 270 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 272 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_location;
#line 272 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp0_;
#line 272 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 2352 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_set_location (GitgRepositoryListBox* self,
                                       GFile* value)
{
	GFile* _tmp0_;
	GBookmarkFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 275 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 277 "../libgitg/gitg-repository-list-box.vala"
	if (self->priv->d_save_repository_bookmarks_id != ((guint) 0)) {
#line 279 "../libgitg/gitg-repository-list-box.vala"
		g_source_remove (self->priv->d_save_repository_bookmarks_id);
#line 280 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_save_repository_bookmarks (self);
#line 2370 "gitg-repository-list-box.c"
	}
#line 283 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 283 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (self->priv->d_location);
#line 283 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_location = _tmp0_;
#line 284 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = g_bookmark_file_new ();
#line 284 "../libgitg/gitg-repository-list-box.vala"
	_g_bookmark_file_free0 (self->priv->d_bookmark_file);
#line 284 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_bookmark_file = _tmp1_;
#line 2384 "gitg-repository-list-box.c"
	{
		GBookmarkFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 288 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = self->priv->d_bookmark_file;
#line 288 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = g_file_get_path (value);
#line 288 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = _tmp3_;
#line 288 "../libgitg/gitg-repository-list-box.vala"
		g_bookmark_file_load_from_file (_tmp2_, _tmp4_, &_inner_error0_);
#line 288 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp4_);
#line 288 "../libgitg/gitg-repository-list-box.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../libgitg/gitg-repository-list-box.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2403 "gitg-repository-list-box.c"
				goto __catch0_g_file_error;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		gboolean _tmp5_;
#line 286 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 292 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = self->priv->_bookmarks_from_recent_files;
#line 292 "../libgitg/gitg-repository-list-box.vala"
		if (_tmp5_) {
#line 295 "../libgitg/gitg-repository-list-box.vala"
			gitg_repository_list_box_copy_bookmarks_from_recent_files (self);
#line 2421 "gitg-repository-list-box.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 286 "../libgitg/gitg-repository-list-box.vala"
		e = _inner_error0_;
#line 286 "../libgitg/gitg-repository-list-box.vala"
		_inner_error0_ = NULL;
#line 300 "../libgitg/gitg-repository-list-box.vala"
		_tmp6_ = stderr;
#line 300 "../libgitg/gitg-repository-list-box.vala"
		_tmp7_ = e;
#line 300 "../libgitg/gitg-repository-list-box.vala"
		_tmp8_ = _tmp7_->message;
#line 300 "../libgitg/gitg-repository-list-box.vala"
		_tmp9_ = string_to_string (_tmp8_);
#line 300 "../libgitg/gitg-repository-list-box.vala"
		_tmp10_ = g_strconcat ("Failed to read repository bookmarks: ", _tmp9_, "\n", NULL);
#line 300 "../libgitg/gitg-repository-list-box.vala"
		_tmp11_ = _tmp10_;
#line 300 "../libgitg/gitg-repository-list-box.vala"
		fprintf (_tmp6_, "%s", _tmp11_);
#line 300 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp11_);
#line 286 "../libgitg/gitg-repository-list-box.vala"
		_g_error_free0 (e);
#line 2456 "gitg-repository-list-box.c"
	}
	__finally0:
#line 286 "../libgitg/gitg-repository-list-box.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 286 "../libgitg/gitg-repository-list-box.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 286 "../libgitg/gitg-repository-list-box.vala"
		g_clear_error (&_inner_error0_);
#line 286 "../libgitg/gitg-repository-list-box.vala"
		return;
#line 2467 "gitg-repository-list-box.c"
	}
#line 275 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_LOCATION_PROPERTY]);
#line 2471 "gitg-repository-list-box.c"
}

gboolean
gitg_repository_list_box_get_has_selection (GitgRepositoryListBox* self)
{
	gboolean result;
	GList* _tmp0_;
#line 632 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 634 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 2483 "gitg-repository-list-box.c"
	{
		GList* row_collection = NULL;
		GList* row_it = NULL;
#line 634 "../libgitg/gitg-repository-list-box.vala"
		row_collection = _tmp0_;
#line 634 "../libgitg/gitg-repository-list-box.vala"
		for (row_it = row_collection; row_it != NULL; row_it = row_it->next) {
#line 2491 "gitg-repository-list-box.c"
			GtkWidget* row = NULL;
#line 634 "../libgitg/gitg-repository-list-box.vala"
			row = (GtkWidget*) row_it->data;
#line 2495 "gitg-repository-list-box.c"
			{
				GitgRepositoryListBoxRow* r = NULL;
				GtkWidget* _tmp1_;
				GitgRepositoryListBoxRow* _tmp2_;
				GitgRepositoryListBoxRow* _tmp3_;
				gboolean _tmp4_;
				gboolean _tmp5_;
#line 636 "../libgitg/gitg-repository-list-box.vala"
				_tmp1_ = row;
#line 636 "../libgitg/gitg-repository-list-box.vala"
				_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow));
#line 636 "../libgitg/gitg-repository-list-box.vala"
				r = _tmp2_;
#line 638 "../libgitg/gitg-repository-list-box.vala"
				_tmp3_ = r;
#line 638 "../libgitg/gitg-repository-list-box.vala"
				_tmp4_ = gitg_repository_list_box_row_get_selected (_tmp3_);
#line 638 "../libgitg/gitg-repository-list-box.vala"
				_tmp5_ = _tmp4_;
#line 638 "../libgitg/gitg-repository-list-box.vala"
				if (_tmp5_) {
#line 640 "../libgitg/gitg-repository-list-box.vala"
					result = TRUE;
#line 640 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (r);
#line 640 "../libgitg/gitg-repository-list-box.vala"
					(row_collection == NULL) ? NULL : (row_collection = (g_list_free (row_collection), NULL));
#line 640 "../libgitg/gitg-repository-list-box.vala"
					return result;
#line 2525 "gitg-repository-list-box.c"
				}
#line 634 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (r);
#line 2529 "gitg-repository-list-box.c"
			}
		}
#line 634 "../libgitg/gitg-repository-list-box.vala"
		(row_collection == NULL) ? NULL : (row_collection = (g_list_free (row_collection), NULL));
#line 2534 "gitg-repository-list-box.c"
	}
#line 644 "../libgitg/gitg-repository-list-box.vala"
	result = FALSE;
#line 644 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 2540 "gitg-repository-list-box.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (n_param_values == 3);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "../libgitg/gitg-repository-list-box.vala"
		data1 = closure->data;
#line 28 "../libgitg/gitg-repository-list-box.vala"
		data2 = param_values->data[0].v_pointer;
#line 2565 "gitg-repository-list-box.c"
	} else {
#line 28 "../libgitg/gitg-repository-list-box.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "../libgitg/gitg-repository-list-box.vala"
		data2 = closure->data;
#line 2571 "gitg-repository-list-box.c"
	}
#line 28 "../libgitg/gitg-repository-list-box.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 2577 "gitg-repository-list-box.c"
}

static inline gpointer
gitg_repository_list_box_row_get_instance_private (GitgRepositoryListBoxRow* self)
{
	return G_STRUCT_MEMBER_P (self, GitgRepositoryListBoxRow_private_offset);
}

static void
gitg_repository_list_box_row_update_branch_label (GitgRepositoryListBoxRow* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 148 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 150 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = self->priv->d_branch_name;
#line 150 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp1_ == NULL) {
#line 150 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = TRUE;
#line 2599 "gitg-repository-list-box.c"
	} else {
		const gchar* _tmp2_;
#line 150 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = self->priv->d_branch_name;
#line 150 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 2606 "gitg-repository-list-box.c"
	}
#line 150 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp0_) {
#line 2610 "gitg-repository-list-box.c"
		GtkLabel* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 153 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = self->priv->d_branch_label;
#line 153 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = self->priv->d_dirname;
#line 153 "../libgitg/gitg-repository-list-box.vala"
		_tmp5_ = g_strdup_printf (_ ("at %s"), _tmp4_);
#line 153 "../libgitg/gitg-repository-list-box.vala"
		_tmp6_ = _tmp5_;
#line 153 "../libgitg/gitg-repository-list-box.vala"
		gtk_label_set_label (_tmp3_, _tmp6_);
#line 153 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp6_);
#line 2627 "gitg-repository-list-box.c"
	} else {
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
#line 155 "../libgitg/gitg-repository-list-box.vala"
		_tmp8_ = self->priv->d_dirname;
#line 155 "../libgitg/gitg-repository-list-box.vala"
		if (_tmp8_ == NULL) {
#line 155 "../libgitg/gitg-repository-list-box.vala"
			_tmp7_ = TRUE;
#line 2637 "gitg-repository-list-box.c"
		} else {
			const gchar* _tmp9_;
#line 155 "../libgitg/gitg-repository-list-box.vala"
			_tmp9_ = self->priv->d_dirname;
#line 155 "../libgitg/gitg-repository-list-box.vala"
			_tmp7_ = g_strcmp0 (_tmp9_, "") == 0;
#line 2644 "gitg-repository-list-box.c"
		}
#line 155 "../libgitg/gitg-repository-list-box.vala"
		if (_tmp7_) {
#line 2648 "gitg-repository-list-box.c"
			GtkLabel* _tmp10_;
			const gchar* _tmp11_;
#line 157 "../libgitg/gitg-repository-list-box.vala"
			_tmp10_ = self->priv->d_branch_label;
#line 157 "../libgitg/gitg-repository-list-box.vala"
			_tmp11_ = self->priv->d_branch_name;
#line 157 "../libgitg/gitg-repository-list-box.vala"
			gtk_label_set_label (_tmp10_, _tmp11_);
#line 2657 "gitg-repository-list-box.c"
		} else {
			GtkLabel* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 162 "../libgitg/gitg-repository-list-box.vala"
			_tmp12_ = self->priv->d_branch_label;
#line 162 "../libgitg/gitg-repository-list-box.vala"
			_tmp13_ = self->priv->d_branch_name;
#line 162 "../libgitg/gitg-repository-list-box.vala"
			_tmp14_ = self->priv->d_dirname;
#line 162 "../libgitg/gitg-repository-list-box.vala"
			_tmp15_ = g_strdup_printf (_ ("%s at %s"), _tmp13_, _tmp14_);
#line 162 "../libgitg/gitg-repository-list-box.vala"
			_tmp16_ = _tmp15_;
#line 162 "../libgitg/gitg-repository-list-box.vala"
			gtk_label_set_label (_tmp12_, _tmp16_);
#line 162 "../libgitg/gitg-repository-list-box.vala"
			_g_free0 (_tmp16_);
#line 2678 "gitg-repository-list-box.c"
		}
	}
}

static void
_vala_GgitOId_free (GgitOId* self)
{
#line 190 "../libgitg/gitg-repository-list-box.vala"
	g_boxed_free (ggit_oid_get_type (), self);
#line 2688 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_row_update_repository_data (GitgRepositoryListBoxRow* self)
{
	gchar* head_name = NULL;
	gchar* _tmp0_;
	gchar* head_description = NULL;
	gchar* _tmp1_;
	GitgRepository* _tmp2_;
	gchar* _tmp64_ = NULL;
	GitgRepository* _tmp65_;
	GtkLabel* _tmp70_;
	const gchar* _tmp71_;
	GtkLabel* _tmp72_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	GError* _inner_error0_ = NULL;
#line 166 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 168 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_strdup ("");
#line 168 "../libgitg/gitg-repository-list-box.vala"
	head_name = _tmp0_;
#line 169 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = g_strdup ("");
#line 169 "../libgitg/gitg-repository-list-box.vala"
	head_description = _tmp1_;
#line 171 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = self->priv->d_repository;
#line 171 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp2_ != NULL) {
#line 2721 "gitg-repository-list-box.c"
		{
			GitgRef* head = NULL;
			GitgRepository* _tmp3_;
			GitgRef* _tmp4_;
			GitgRef* _tmp5_;
			GitgParsedRefName* _tmp6_;
			GitgParsedRefName* _tmp7_;
			GitgParsedRefName* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GgitObject* _tmp11_ = NULL;
			GitgRef* _tmp12_;
			GgitObject* _tmp13_;
			GgitCommit* commit = NULL;
			GgitCommit* _tmp14_;
			GgitTree* tree = NULL;
			GgitCommit* _tmp15_;
			GgitTree* _tmp16_;
			GgitOId* entry_id = NULL;
			GgitOId* _tmp30_;
#line 175 "../libgitg/gitg-repository-list-box.vala"
			_tmp3_ = self->priv->d_repository;
#line 175 "../libgitg/gitg-repository-list-box.vala"
			_tmp4_ = gitg_repository_get_head (_tmp3_, &_inner_error0_);
#line 175 "../libgitg/gitg-repository-list-box.vala"
			head = _tmp4_;
#line 175 "../libgitg/gitg-repository-list-box.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2750 "gitg-repository-list-box.c"
				goto __catch0_g_error;
			}
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_tmp5_ = head;
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_tmp6_ = gitg_ref_get_parsed_name (_tmp5_);
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_tmp7_ = _tmp6_;
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_tmp8_ = _tmp7_;
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_tmp9_ = gitg_parsed_ref_name_get_shortname (_tmp8_);
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_tmp10_ = _tmp9_;
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_g_free0 (head_name);
#line 176 "../libgitg/gitg-repository-list-box.vala"
			head_name = _tmp10_;
#line 176 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (_tmp8_);
#line 178 "../libgitg/gitg-repository-list-box.vala"
			_tmp12_ = head;
#line 178 "../libgitg/gitg-repository-list-box.vala"
			_tmp13_ = ggit_ref_lookup ((GgitRef*) _tmp12_, &_inner_error0_);
#line 178 "../libgitg/gitg-repository-list-box.vala"
			_tmp11_ = _tmp13_;
#line 178 "../libgitg/gitg-repository-list-box.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (head);
#line 2781 "gitg-repository-list-box.c"
				goto __catch0_g_error;
			}
#line 178 "../libgitg/gitg-repository-list-box.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, ggit_commit_get_type (), GgitCommit));
#line 178 "../libgitg/gitg-repository-list-box.vala"
			commit = _tmp14_;
#line 179 "../libgitg/gitg-repository-list-box.vala"
			_tmp15_ = commit;
#line 179 "../libgitg/gitg-repository-list-box.vala"
			_tmp16_ = ggit_commit_get_tree (_tmp15_);
#line 179 "../libgitg/gitg-repository-list-box.vala"
			tree = _tmp16_;
#line 181 "../libgitg/gitg-repository-list-box.vala"
			entry_id = NULL;
#line 2796 "gitg-repository-list-box.c"
			{
				gint i = 0;
#line 183 "../libgitg/gitg-repository-list-box.vala"
				i = 0;
#line 2801 "gitg-repository-list-box.c"
				{
					gboolean _tmp17_ = FALSE;
#line 183 "../libgitg/gitg-repository-list-box.vala"
					_tmp17_ = TRUE;
#line 183 "../libgitg/gitg-repository-list-box.vala"
					while (TRUE) {
#line 2808 "gitg-repository-list-box.c"
						GgitTree* _tmp19_;
						GgitTreeEntry* entry = NULL;
						GgitTree* _tmp20_;
						GgitTreeEntry* _tmp21_;
						gchar* name = NULL;
						GgitTreeEntry* _tmp22_;
						const gchar* _tmp23_;
						gchar* _tmp24_;
						gboolean _tmp25_ = FALSE;
						const gchar* _tmp26_;
#line 183 "../libgitg/gitg-repository-list-box.vala"
						if (!_tmp17_) {
#line 2821 "gitg-repository-list-box.c"
							gint _tmp18_;
#line 183 "../libgitg/gitg-repository-list-box.vala"
							_tmp18_ = i;
#line 183 "../libgitg/gitg-repository-list-box.vala"
							i = _tmp18_ + 1;
#line 2827 "gitg-repository-list-box.c"
						}
#line 183 "../libgitg/gitg-repository-list-box.vala"
						_tmp17_ = FALSE;
#line 183 "../libgitg/gitg-repository-list-box.vala"
						_tmp19_ = tree;
#line 183 "../libgitg/gitg-repository-list-box.vala"
						if (!(((guint) i) < ggit_tree_size (_tmp19_))) {
#line 183 "../libgitg/gitg-repository-list-box.vala"
							break;
#line 2837 "gitg-repository-list-box.c"
						}
#line 185 "../libgitg/gitg-repository-list-box.vala"
						_tmp20_ = tree;
#line 185 "../libgitg/gitg-repository-list-box.vala"
						_tmp21_ = ggit_tree_get (_tmp20_, (guint) i);
#line 185 "../libgitg/gitg-repository-list-box.vala"
						entry = _tmp21_;
#line 186 "../libgitg/gitg-repository-list-box.vala"
						_tmp22_ = entry;
#line 186 "../libgitg/gitg-repository-list-box.vala"
						_tmp23_ = ggit_tree_entry_get_name (_tmp22_);
#line 186 "../libgitg/gitg-repository-list-box.vala"
						_tmp24_ = g_strdup (_tmp23_);
#line 186 "../libgitg/gitg-repository-list-box.vala"
						name = _tmp24_;
#line 188 "../libgitg/gitg-repository-list-box.vala"
						_tmp26_ = name;
#line 188 "../libgitg/gitg-repository-list-box.vala"
						if (_tmp26_ != NULL) {
#line 2857 "gitg-repository-list-box.c"
							const gchar* _tmp27_;
#line 188 "../libgitg/gitg-repository-list-box.vala"
							_tmp27_ = name;
#line 188 "../libgitg/gitg-repository-list-box.vala"
							_tmp25_ = g_str_has_suffix (_tmp27_, ".doap");
#line 2863 "gitg-repository-list-box.c"
						} else {
#line 188 "../libgitg/gitg-repository-list-box.vala"
							_tmp25_ = FALSE;
#line 2867 "gitg-repository-list-box.c"
						}
#line 188 "../libgitg/gitg-repository-list-box.vala"
						if (_tmp25_) {
#line 2871 "gitg-repository-list-box.c"
							GgitTreeEntry* _tmp28_;
							GgitOId* _tmp29_;
#line 190 "../libgitg/gitg-repository-list-box.vala"
							_tmp28_ = entry;
#line 190 "../libgitg/gitg-repository-list-box.vala"
							_tmp29_ = ggit_tree_entry_get_id (_tmp28_);
#line 190 "../libgitg/gitg-repository-list-box.vala"
							__vala_GgitOId_free0 (entry_id);
#line 190 "../libgitg/gitg-repository-list-box.vala"
							entry_id = _tmp29_;
#line 191 "../libgitg/gitg-repository-list-box.vala"
							_g_free0 (name);
#line 191 "../libgitg/gitg-repository-list-box.vala"
							_ggit_tree_entry_unref0 (entry);
#line 191 "../libgitg/gitg-repository-list-box.vala"
							break;
#line 2888 "gitg-repository-list-box.c"
						}
#line 183 "../libgitg/gitg-repository-list-box.vala"
						_g_free0 (name);
#line 183 "../libgitg/gitg-repository-list-box.vala"
						_ggit_tree_entry_unref0 (entry);
#line 2894 "gitg-repository-list-box.c"
					}
				}
			}
#line 195 "../libgitg/gitg-repository-list-box.vala"
			_tmp30_ = entry_id;
#line 195 "../libgitg/gitg-repository-list-box.vala"
			if (_tmp30_ != NULL) {
#line 2902 "gitg-repository-list-box.c"
				GgitBlob* blob = NULL;
				GitgRepository* _tmp31_;
				GgitOId* _tmp32_;
				gpointer _tmp33_;
				guint8* content = NULL;
				GgitBlob* _tmp34_;
				gsize _tmp35_ = 0;
				guint8* _tmp36_;
				gint content_length1;
				gint _content_size_;
				IdeDoap* doap = NULL;
				IdeDoap* _tmp37_;
				IdeDoap* _tmp38_;
				guint8* _tmp39_;
				gint _tmp39__length1;
				IdeDoap* _tmp40_;
				const gchar* _tmp41_;
				gchar* _tmp42_;
				IdeDoap* _tmp43_;
				gchar** _tmp44_;
				gchar** _tmp45_;
#line 197 "../libgitg/gitg-repository-list-box.vala"
				_tmp31_ = self->priv->d_repository;
#line 197 "../libgitg/gitg-repository-list-box.vala"
				_tmp32_ = entry_id;
#line 197 "../libgitg/gitg-repository-list-box.vala"
				_tmp33_ = gitg_repository_lookup (_tmp31_, ggit_blob_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp32_, &_inner_error0_);
#line 197 "../libgitg/gitg-repository-list-box.vala"
				blob = (GgitBlob*) _tmp33_;
#line 197 "../libgitg/gitg-repository-list-box.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../libgitg/gitg-repository-list-box.vala"
					__vala_GgitOId_free0 (entry_id);
#line 197 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (tree);
#line 197 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (commit);
#line 197 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (_tmp11_);
#line 197 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (head);
#line 2944 "gitg-repository-list-box.c"
					goto __catch0_g_error;
				}
#line 199 "../libgitg/gitg-repository-list-box.vala"
				_tmp34_ = blob;
#line 199 "../libgitg/gitg-repository-list-box.vala"
				_tmp36_ = ggit_blob_get_raw_content (_tmp34_, &_tmp35_);
#line 199 "../libgitg/gitg-repository-list-box.vala"
				content = _tmp36_;
#line 199 "../libgitg/gitg-repository-list-box.vala"
				content_length1 = _tmp35_;
#line 199 "../libgitg/gitg-repository-list-box.vala"
				_content_size_ = content_length1;
#line 200 "../libgitg/gitg-repository-list-box.vala"
				_tmp37_ = ide_doap_new ();
#line 200 "../libgitg/gitg-repository-list-box.vala"
				doap = _tmp37_;
#line 201 "../libgitg/gitg-repository-list-box.vala"
				_tmp38_ = doap;
#line 201 "../libgitg/gitg-repository-list-box.vala"
				_tmp39_ = content;
#line 201 "../libgitg/gitg-repository-list-box.vala"
				_tmp39__length1 = content_length1;
#line 201 "../libgitg/gitg-repository-list-box.vala"
				ide_doap_load_from_data (_tmp38_, (const gchar*) _tmp39_, (gsize) -1, &_inner_error0_);
#line 201 "../libgitg/gitg-repository-list-box.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (doap);
#line 201 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (blob);
#line 201 "../libgitg/gitg-repository-list-box.vala"
					__vala_GgitOId_free0 (entry_id);
#line 201 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (tree);
#line 201 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (commit);
#line 201 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (_tmp11_);
#line 201 "../libgitg/gitg-repository-list-box.vala"
					_g_object_unref0 (head);
#line 2985 "gitg-repository-list-box.c"
					goto __catch0_g_error;
				}
#line 203 "../libgitg/gitg-repository-list-box.vala"
				_tmp40_ = doap;
#line 203 "../libgitg/gitg-repository-list-box.vala"
				_tmp41_ = ide_doap_get_shortdesc (_tmp40_);
#line 203 "../libgitg/gitg-repository-list-box.vala"
				_tmp42_ = g_strdup (_tmp41_);
#line 203 "../libgitg/gitg-repository-list-box.vala"
				_g_free0 (head_description);
#line 203 "../libgitg/gitg-repository-list-box.vala"
				head_description = _tmp42_;
#line 205 "../libgitg/gitg-repository-list-box.vala"
				_tmp43_ = doap;
#line 205 "../libgitg/gitg-repository-list-box.vala"
				_tmp45_ = _tmp44_ = ide_doap_get_languages (_tmp43_);
#line 3002 "gitg-repository-list-box.c"
				{
					gchar** lang_collection = NULL;
					gint lang_collection_length1 = 0;
					gint _lang_collection_size_ = 0;
					gint lang_it = 0;
#line 205 "../libgitg/gitg-repository-list-box.vala"
					lang_collection = _tmp45_;
#line 205 "../libgitg/gitg-repository-list-box.vala"
					lang_collection_length1 = _vala_array_length (_tmp44_);
#line 205 "../libgitg/gitg-repository-list-box.vala"
					for (lang_it = 0; lang_it < lang_collection_length1; lang_it = lang_it + 1) {
#line 3014 "gitg-repository-list-box.c"
						gchar* _tmp46_;
						gchar* lang = NULL;
#line 205 "../libgitg/gitg-repository-list-box.vala"
						_tmp46_ = g_strdup (lang_collection[lang_it]);
#line 205 "../libgitg/gitg-repository-list-box.vala"
						lang = _tmp46_;
#line 3021 "gitg-repository-list-box.c"
						{
							GtkFrame* frame = NULL;
							GtkFrame* _tmp47_;
							GtkFrame* _tmp48_;
							GtkFrame* _tmp49_;
							GtkStyleContext* _tmp50_;
							GtkFrame* _tmp51_;
							GtkLabel* label = NULL;
							const gchar* _tmp52_;
							GtkLabel* _tmp53_;
							PangoAttrList* attr_list = NULL;
							PangoAttrList* _tmp54_;
							PangoAttrList* _tmp55_;
							PangoAttribute* _tmp56_;
							GtkLabel* _tmp57_;
							PangoAttrList* _tmp58_;
							GtkLabel* _tmp59_;
							GtkFrame* _tmp60_;
							GtkLabel* _tmp61_;
							GtkBox* _tmp62_;
							GtkFrame* _tmp63_;
#line 207 "../libgitg/gitg-repository-list-box.vala"
							_tmp47_ = (GtkFrame*) gtk_frame_new (NULL);
#line 207 "../libgitg/gitg-repository-list-box.vala"
							g_object_ref_sink (_tmp47_);
#line 207 "../libgitg/gitg-repository-list-box.vala"
							frame = _tmp47_;
#line 208 "../libgitg/gitg-repository-list-box.vala"
							_tmp48_ = frame;
#line 208 "../libgitg/gitg-repository-list-box.vala"
							gtk_frame_set_shadow_type (_tmp48_, GTK_SHADOW_NONE);
#line 209 "../libgitg/gitg-repository-list-box.vala"
							_tmp49_ = frame;
#line 209 "../libgitg/gitg-repository-list-box.vala"
							_tmp50_ = gtk_widget_get_style_context ((GtkWidget*) _tmp49_);
#line 209 "../libgitg/gitg-repository-list-box.vala"
							gtk_style_context_add_class (_tmp50_, "language-frame");
#line 210 "../libgitg/gitg-repository-list-box.vala"
							_tmp51_ = frame;
#line 210 "../libgitg/gitg-repository-list-box.vala"
							gtk_widget_show ((GtkWidget*) _tmp51_);
#line 212 "../libgitg/gitg-repository-list-box.vala"
							_tmp52_ = lang;
#line 212 "../libgitg/gitg-repository-list-box.vala"
							_tmp53_ = (GtkLabel*) gtk_label_new (_tmp52_);
#line 212 "../libgitg/gitg-repository-list-box.vala"
							g_object_ref_sink (_tmp53_);
#line 212 "../libgitg/gitg-repository-list-box.vala"
							label = _tmp53_;
#line 213 "../libgitg/gitg-repository-list-box.vala"
							_tmp54_ = pango_attr_list_new ();
#line 213 "../libgitg/gitg-repository-list-box.vala"
							attr_list = _tmp54_;
#line 214 "../libgitg/gitg-repository-list-box.vala"
							_tmp55_ = attr_list;
#line 214 "../libgitg/gitg-repository-list-box.vala"
							_tmp56_ = pango_attr_scale_new (PANGO_SCALE_SMALL);
#line 214 "../libgitg/gitg-repository-list-box.vala"
							pango_attr_list_insert (_tmp55_, _tmp56_);
#line 215 "../libgitg/gitg-repository-list-box.vala"
							_tmp57_ = label;
#line 215 "../libgitg/gitg-repository-list-box.vala"
							_tmp58_ = attr_list;
#line 215 "../libgitg/gitg-repository-list-box.vala"
							gtk_label_set_attributes (_tmp57_, _tmp58_);
#line 216 "../libgitg/gitg-repository-list-box.vala"
							_tmp59_ = label;
#line 216 "../libgitg/gitg-repository-list-box.vala"
							gtk_widget_show ((GtkWidget*) _tmp59_);
#line 218 "../libgitg/gitg-repository-list-box.vala"
							_tmp60_ = frame;
#line 218 "../libgitg/gitg-repository-list-box.vala"
							_tmp61_ = label;
#line 218 "../libgitg/gitg-repository-list-box.vala"
							gtk_container_add ((GtkContainer*) _tmp60_, (GtkWidget*) _tmp61_);
#line 219 "../libgitg/gitg-repository-list-box.vala"
							_tmp62_ = self->priv->d_languages_box;
#line 219 "../libgitg/gitg-repository-list-box.vala"
							_tmp63_ = frame;
#line 219 "../libgitg/gitg-repository-list-box.vala"
							gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
#line 205 "../libgitg/gitg-repository-list-box.vala"
							_pango_attr_list_unref0 (attr_list);
#line 205 "../libgitg/gitg-repository-list-box.vala"
							_g_object_unref0 (label);
#line 205 "../libgitg/gitg-repository-list-box.vala"
							_g_object_unref0 (frame);
#line 205 "../libgitg/gitg-repository-list-box.vala"
							_g_free0 (lang);
#line 3111 "gitg-repository-list-box.c"
						}
					}
				}
#line 195 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (doap);
#line 195 "../libgitg/gitg-repository-list-box.vala"
				_g_object_unref0 (blob);
#line 3119 "gitg-repository-list-box.c"
			}
#line 173 "../libgitg/gitg-repository-list-box.vala"
			__vala_GgitOId_free0 (entry_id);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (tree);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (commit);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (_tmp11_);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			_g_object_unref0 (head);
#line 3131 "gitg-repository-list-box.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 173 "../libgitg/gitg-repository-list-box.vala"
			g_clear_error (&_inner_error0_);
#line 3138 "gitg-repository-list-box.c"
		}
		__finally0:
#line 173 "../libgitg/gitg-repository-list-box.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../libgitg/gitg-repository-list-box.vala"
			_g_free0 (head_description);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			_g_free0 (head_name);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			g_clear_error (&_inner_error0_);
#line 173 "../libgitg/gitg-repository-list-box.vala"
			return;
#line 3153 "gitg-repository-list-box.c"
		}
	}
#line 225 "../libgitg/gitg-repository-list-box.vala"
	_tmp65_ = self->priv->d_repository;
#line 225 "../libgitg/gitg-repository-list-box.vala"
	if (_tmp65_ != NULL) {
#line 3160 "gitg-repository-list-box.c"
		GitgRepository* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_tmp66_ = self->priv->d_repository;
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_tmp67_ = gitg_repository_get_name (_tmp66_);
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_tmp68_ = _tmp67_;
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp64_);
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_tmp64_ = _tmp68_;
#line 3174 "gitg-repository-list-box.c"
	} else {
		gchar* _tmp69_;
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_tmp69_ = g_strdup ("");
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_g_free0 (_tmp64_);
#line 225 "../libgitg/gitg-repository-list-box.vala"
		_tmp64_ = _tmp69_;
#line 3183 "gitg-repository-list-box.c"
	}
#line 225 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_set_repository_name (self, _tmp64_);
#line 227 "../libgitg/gitg-repository-list-box.vala"
	_tmp70_ = self->priv->d_description_label;
#line 227 "../libgitg/gitg-repository-list-box.vala"
	_tmp71_ = head_description;
#line 227 "../libgitg/gitg-repository-list-box.vala"
	gtk_label_set_label (_tmp70_, _tmp71_);
#line 228 "../libgitg/gitg-repository-list-box.vala"
	_tmp72_ = self->priv->d_description_label;
#line 228 "../libgitg/gitg-repository-list-box.vala"
	_tmp73_ = head_description;
#line 228 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp72_, g_strcmp0 (_tmp73_, "") != 0);
#line 230 "../libgitg/gitg-repository-list-box.vala"
	_tmp74_ = head_name;
#line 230 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_set_branch_name (self, _tmp74_);
#line 166 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (_tmp64_);
#line 166 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (head_description);
#line 166 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (head_name);
#line 3209 "gitg-repository-list-box.c"
}

GitgRepositoryListBoxRow*
gitg_repository_list_box_row_construct (GType object_type,
                                        GitgRepository* repository,
                                        const gchar* dirname)
{
	GitgRepositoryListBoxRow * self = NULL;
#line 254 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (dirname != NULL, NULL);
#line 256 "../libgitg/gitg-repository-list-box.vala"
	self = (GitgRepositoryListBoxRow*) g_object_new (object_type, "repository", repository, "dirname", dirname, NULL);
#line 254 "../libgitg/gitg-repository-list-box.vala"
	return self;
#line 3224 "gitg-repository-list-box.c"
}

GitgRepositoryListBoxRow*
gitg_repository_list_box_row_new (GitgRepository* repository,
                                  const gchar* dirname)
{
#line 254 "../libgitg/gitg-repository-list-box.vala"
	return gitg_repository_list_box_row_construct (GITG_REPOSITORY_LIST_BOX_TYPE_ROW, repository, dirname);
#line 3233 "gitg-repository-list-box.c"
}

GitgSelectionMode
gitg_repository_list_box_row_get_mode (GitgRepositoryListBoxRow* self)
{
	GitgSelectionMode result;
#line 66 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../libgitg/gitg-repository-list-box.vala"
	result = self->priv->d_mode;
#line 66 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3246 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_mode (GitgRepositoryListBoxRow* self,
                                       GitgSelectionMode value)
{
#line 68 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 70 "../libgitg/gitg-repository-list-box.vala"
	if (self->priv->d_mode != value) {
#line 3257 "gitg-repository-list-box.c"
		GtkRevealer* _tmp0_;
		GtkCheckButton* _tmp1_;
#line 72 "../libgitg/gitg-repository-list-box.vala"
		self->priv->d_mode = value;
#line 74 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = self->priv->d_remove_revealer;
#line 74 "../libgitg/gitg-repository-list-box.vala"
		gtk_revealer_set_reveal_child (_tmp0_, self->priv->d_mode == GITG_SELECTION_MODE_SELECTION);
#line 76 "../libgitg/gitg-repository-list-box.vala"
		_tmp1_ = self->priv->d_remove_check_button;
#line 76 "../libgitg/gitg-repository-list-box.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, FALSE);
#line 3270 "gitg-repository-list-box.c"
	}
#line 68 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_MODE_PROPERTY]);
#line 3274 "gitg-repository-list-box.c"
}

gboolean
gitg_repository_list_box_row_get_selected (GitgRepositoryListBoxRow* self)
{
	gboolean result;
#line 83 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../libgitg/gitg-repository-list-box.vala"
	result = self->priv->_selected;
#line 83 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3287 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_selected (GitgRepositoryListBoxRow* self,
                                           gboolean value)
{
	gboolean old_value;
#line 83 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 83 "../libgitg/gitg-repository-list-box.vala"
	old_value = gitg_repository_list_box_row_get_selected (self);
#line 83 "../libgitg/gitg-repository-list-box.vala"
	if (old_value != value) {
#line 83 "../libgitg/gitg-repository-list-box.vala"
		self->priv->_selected = value;
#line 83 "../libgitg/gitg-repository-list-box.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_SELECTED_PROPERTY]);
#line 3305 "gitg-repository-list-box.c"
	}
}

GitgRepository*
gitg_repository_list_box_row_get_repository (GitgRepositoryListBoxRow* self)
{
	GitgRepository* result;
	GitgRepository* _tmp0_;
#line 97 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_repository;
#line 97 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp0_;
#line 97 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3322 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_repository (GitgRepositoryListBoxRow* self,
                                             GitgRepository* value)
{
	GitgRepository* _tmp0_;
#line 98 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 100 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 100 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (self->priv->d_repository);
#line 100 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_repository = _tmp0_;
#line 101 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_update_repository_data (self);
#line 98 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_PROPERTY]);
#line 3342 "gitg-repository-list-box.c"
}

gboolean
gitg_repository_list_box_row_get_can_remove (GitgRepositoryListBoxRow* self)
{
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 107 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_remove_check_button;
#line 107 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
#line 107 "../libgitg/gitg-repository-list-box.vala"
	_tmp2_ = _tmp1_;
#line 107 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp2_;
#line 107 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3364 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_can_remove (GitgRepositoryListBoxRow* self,
                                             gboolean value)
{
	GtkCheckButton* _tmp0_;
#line 108 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 108 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_remove_check_button;
#line 108 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, value);
#line 108 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_CAN_REMOVE_PROPERTY]);
#line 3380 "gitg-repository-list-box.c"
}

GDateTime*
gitg_repository_list_box_row_get_time (GitgRepositoryListBoxRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 113 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_time;
#line 113 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp0_;
#line 113 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3396 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_time (GitgRepositoryListBoxRow* self,
                                       GDateTime* value)
{
	GDateTime* _tmp0_;
#line 114 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 114 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 114 "../libgitg/gitg-repository-list-box.vala"
	_g_date_time_unref0 (self->priv->d_time);
#line 114 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_time = _tmp0_;
#line 114 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_TIME_PROPERTY]);
#line 3414 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_fraction (GitgRepositoryListBoxRow* self,
                                           gdouble value)
{
	GitgProgressBin* _tmp0_;
#line 119 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 119 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_progress_bin;
#line 119 "../libgitg/gitg-repository-list-box.vala"
	gitg_progress_bin_set_fraction (_tmp0_, value);
#line 119 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_FRACTION_PROPERTY]);
#line 3430 "gitg-repository-list-box.c"
}

const gchar*
gitg_repository_list_box_row_get_repository_name (GitgRepositoryListBoxRow* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 124 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_repository_label;
#line 124 "../libgitg/gitg-repository-list-box.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 124 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp1_;
#line 124 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3449 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_repository_name (GitgRepositoryListBoxRow* self,
                                                  const gchar* value)
{
	GtkLabel* _tmp0_;
#line 125 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 125 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_repository_label;
#line 125 "../libgitg/gitg-repository-list-box.vala"
	gtk_label_set_label (_tmp0_, value);
#line 125 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_NAME_PROPERTY]);
#line 3465 "gitg-repository-list-box.c"
}

const gchar*
gitg_repository_list_box_row_get_dirname (GitgRepositoryListBoxRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 130 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_dirname;
#line 130 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp0_;
#line 130 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3481 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_dirname (GitgRepositoryListBoxRow* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
#line 131 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 133 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_strdup (value);
#line 133 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (self->priv->d_dirname);
#line 133 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_dirname = _tmp0_;
#line 134 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_update_branch_label (self);
#line 131 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_DIRNAME_PROPERTY]);
#line 3501 "gitg-repository-list-box.c"
}

const gchar*
gitg_repository_list_box_row_get_branch_name (GitgRepositoryListBoxRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 140 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_branch_name;
#line 140 "../libgitg/gitg-repository-list-box.vala"
	result = _tmp0_;
#line 140 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3517 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_branch_name (GitgRepositoryListBoxRow* self,
                                              const gchar* value)
{
	gchar* _tmp0_;
#line 141 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 143 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_strdup (value);
#line 143 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (self->priv->d_branch_name);
#line 143 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_branch_name = _tmp0_;
#line 144 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_update_branch_label (self);
#line 141 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_BRANCH_NAME_PROPERTY]);
#line 3537 "gitg-repository-list-box.c"
}

gboolean
gitg_repository_list_box_row_get_loading (GitgRepositoryListBoxRow* self)
{
	gboolean result;
#line 235 "../libgitg/gitg-repository-list-box.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 235 "../libgitg/gitg-repository-list-box.vala"
	result = self->priv->d_loading;
#line 235 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3550 "gitg-repository-list-box.c"
}

void
gitg_repository_list_box_row_set_loading (GitgRepositoryListBoxRow* self,
                                          gboolean value)
{
#line 236 "../libgitg/gitg-repository-list-box.vala"
	g_return_if_fail (self != NULL);
#line 238 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_loading = value;
#line 240 "../libgitg/gitg-repository-list-box.vala"
	if (!self->priv->d_loading) {
#line 3563 "gitg-repository-list-box.c"
		GtkSpinner* _tmp0_;
		GtkSpinner* _tmp1_;
		GitgProgressBin* _tmp2_;
#line 242 "../libgitg/gitg-repository-list-box.vala"
		_tmp0_ = self->priv->d_spinner;
#line 242 "../libgitg/gitg-repository-list-box.vala"
		gtk_spinner_stop (_tmp0_);
#line 243 "../libgitg/gitg-repository-list-box.vala"
		_tmp1_ = self->priv->d_spinner;
#line 243 "../libgitg/gitg-repository-list-box.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 244 "../libgitg/gitg-repository-list-box.vala"
		_tmp2_ = self->priv->d_progress_bin;
#line 244 "../libgitg/gitg-repository-list-box.vala"
		gitg_progress_bin_set_fraction (_tmp2_, (gdouble) 0);
#line 3579 "gitg-repository-list-box.c"
	} else {
		GtkSpinner* _tmp3_;
		GtkSpinner* _tmp4_;
#line 248 "../libgitg/gitg-repository-list-box.vala"
		_tmp3_ = self->priv->d_spinner;
#line 248 "../libgitg/gitg-repository-list-box.vala"
		gtk_widget_show ((GtkWidget*) _tmp3_);
#line 249 "../libgitg/gitg-repository-list-box.vala"
		_tmp4_ = self->priv->d_spinner;
#line 249 "../libgitg/gitg-repository-list-box.vala"
		gtk_spinner_start (_tmp4_);
#line 3591 "gitg-repository-list-box.c"
	}
#line 236 "../libgitg/gitg-repository-list-box.vala"
	g_object_notify_by_pspec ((GObject *) self, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_LOADING_PROPERTY]);
#line 3595 "gitg-repository-list-box.c"
}

static GObject *
gitg_repository_list_box_row_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GitgRepositoryListBoxRow * self;
	GtkCheckButton* _tmp0_;
#line 86 "../libgitg/gitg-repository-list-box.vala"
	parent_class = G_OBJECT_CLASS (gitg_repository_list_box_row_parent_class);
#line 86 "../libgitg/gitg-repository-list-box.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 86 "../libgitg/gitg-repository-list-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow);
#line 88 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = self->priv->d_remove_check_button;
#line 88 "../libgitg/gitg-repository-list-box.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp0_, "active", (GObject*) self, "selected", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 86 "../libgitg/gitg-repository-list-box.vala"
	return obj;
#line 3619 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_row_class_init (GitgRepositoryListBoxRowClass * klass,
                                         gpointer klass_data)
{
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_parent_class = g_type_class_peek_parent (klass);
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_type_class_adjust_private_offset (klass, &GitgRepositoryListBoxRow_private_offset);
#line 36 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_repository_list_box_row_get_property;
#line 36 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_repository_list_box_row_set_property;
#line 36 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->constructor = gitg_repository_list_box_row_constructor;
#line 36 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_repository_list_box_row_finalize;
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_MODE_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", GITG_TYPE_SELECTION_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_SELECTED_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_PROPERTY] = g_param_spec_object ("repository", "repository", "repository", GITG_TYPE_REPOSITORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_CAN_REMOVE_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_CAN_REMOVE_PROPERTY] = g_param_spec_boolean ("can-remove", "can-remove", "can-remove", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_TIME_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_TIME_PROPERTY] = g_param_spec_boxed ("time", "time", "time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_FRACTION_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_FRACTION_PROPERTY] = g_param_spec_double ("fraction", "fraction", "fraction", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_NAME_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_NAME_PROPERTY] = g_param_spec_string ("repository-name", "repository-name", "repository-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_DIRNAME_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_DIRNAME_PROPERTY] = g_param_spec_string ("dirname", "dirname", "dirname", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_BRANCH_NAME_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_BRANCH_NAME_PROPERTY] = g_param_spec_string ("branch-name", "branch-name", "branch-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_ROW_LOADING_PROPERTY, gitg_repository_list_box_row_properties[GITG_REPOSITORY_LIST_BOX_ROW_LOADING_PROPERTY] = g_param_spec_boolean ("loading", "loading", "loading", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/gitg/ui/gitg-repository-list-box-row.ui");
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_row_signals[GITG_REPOSITORY_LIST_BOX_ROW_REQUEST_REMOVE_SIGNAL] = g_signal_new ("request-remove", GITG_REPOSITORY_LIST_BOX_TYPE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_progress_bin", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_progress_bin));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_repository_label", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_repository_label));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_description_label", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_description_label));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_branch_label", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_branch_label));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_spinner", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_spinner));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_remove_check_button", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_remove_check_button));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_remove_revealer", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_remove_revealer));
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "d_languages_box", FALSE, GitgRepositoryListBoxRow_private_offset + G_STRUCT_OFFSET (GitgRepositoryListBoxRowPrivate, d_languages_box));
#line 3678 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_row_instance_init (GitgRepositoryListBoxRow * self,
                                            gpointer klass)
{
	GDateTime* _tmp0_;
#line 36 "../libgitg/gitg-repository-list-box.vala"
	self->priv = gitg_repository_list_box_row_get_instance_private (self);
#line 39 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 39 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_time = _tmp0_;
#line 36 "../libgitg/gitg-repository-list-box.vala"
	g_type_ensure (GITG_TYPE_PROGRESS_BIN);
#line 36 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 3696 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_row_finalize (GObject * obj)
{
	GitgRepositoryListBoxRow * self;
#line 36 "../libgitg/gitg-repository-list-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow);
#line 38 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (self->priv->d_repository);
#line 39 "../libgitg/gitg-repository-list-box.vala"
	_g_date_time_unref0 (self->priv->d_time);
#line 61 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (self->priv->d_dirname);
#line 62 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (self->priv->d_branch_name);
#line 36 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (gitg_repository_list_box_row_parent_class)->finalize (obj);
#line 3715 "gitg-repository-list-box.c"
}

 G_GNUC_NO_INLINE static GType
gitg_repository_list_box_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgRepositoryListBoxRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_repository_list_box_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgRepositoryListBoxRow), 0, (GInstanceInitFunc) gitg_repository_list_box_row_instance_init, NULL };
	GType gitg_repository_list_box_row_type_id;
	gitg_repository_list_box_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "GitgRepositoryListBoxRow", &g_define_type_info, 0);
	GitgRepositoryListBoxRow_private_offset = g_type_add_instance_private (gitg_repository_list_box_row_type_id, sizeof (GitgRepositoryListBoxRowPrivate));
	return gitg_repository_list_box_row_type_id;
}

GType
gitg_repository_list_box_row_get_type (void)
{
	static gsize gitg_repository_list_box_row_type_id__once = 0;
	if (g_once_init_enter (&gitg_repository_list_box_row_type_id__once)) {
		GType gitg_repository_list_box_row_type_id;
		gitg_repository_list_box_row_type_id = gitg_repository_list_box_row_get_type_once ();
		g_once_init_leave (&gitg_repository_list_box_row_type_id__once, gitg_repository_list_box_row_type_id);
	}
	return gitg_repository_list_box_row_type_id__once;
}

static void
_vala_gitg_repository_list_box_row_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	GitgRepositoryListBoxRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow);
#line 36 "../libgitg/gitg-repository-list-box.vala"
	switch (property_id) {
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_MODE_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_enum (value, gitg_repository_list_box_row_get_mode (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_SELECTED_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_boolean (value, gitg_repository_list_box_row_get_selected (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_object (value, gitg_repository_list_box_row_get_repository (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_CAN_REMOVE_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_boolean (value, gitg_repository_list_box_row_get_can_remove (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_TIME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_boxed (value, gitg_repository_list_box_row_get_time (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_NAME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_string (value, gitg_repository_list_box_row_get_repository_name (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_DIRNAME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_string (value, gitg_repository_list_box_row_get_dirname (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_BRANCH_NAME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_string (value, gitg_repository_list_box_row_get_branch_name (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_LOADING_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_boolean (value, gitg_repository_list_box_row_get_loading (self));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 3804 "gitg-repository-list-box.c"
		default:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 3810 "gitg-repository-list-box.c"
	}
}

static void
_vala_gitg_repository_list_box_row_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	GitgRepositoryListBoxRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_REPOSITORY_LIST_BOX_TYPE_ROW, GitgRepositoryListBoxRow);
#line 36 "../libgitg/gitg-repository-list-box.vala"
	switch (property_id) {
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_MODE_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_mode (self, g_value_get_enum (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_SELECTED_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_selected (self, g_value_get_boolean (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_repository (self, g_value_get_object (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_CAN_REMOVE_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_can_remove (self, g_value_get_boolean (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_TIME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_time (self, g_value_get_boxed (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_FRACTION_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_fraction (self, g_value_get_double (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_REPOSITORY_NAME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_repository_name (self, g_value_get_string (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_DIRNAME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_dirname (self, g_value_get_string (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_BRANCH_NAME_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_branch_name (self, g_value_get_string (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 36 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_ROW_LOADING_PROPERTY:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_row_set_loading (self, g_value_get_boolean (value));
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 3884 "gitg-repository-list-box.c"
		default:
#line 36 "../libgitg/gitg-repository-list-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 3890 "gitg-repository-list-box.c"
	}
}

static void
_gitg_repository_list_box_update_header_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                         GtkListBoxRow* before,
                                                                         gpointer self)
{
#line 371 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_update_header ((GitgRepositoryListBox*) self, row, before);
#line 3901 "gitg-repository-list-box.c"
}

static gboolean
_gitg_repository_list_box_filter_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                           gpointer self)
{
	gboolean result;
	result = gitg_repository_list_box_filter ((GitgRepositoryListBox*) self, row);
#line 372 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3912 "gitg-repository-list-box.c"
}

static gint
_gitg_repository_list_box_compare_widgets_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                  GtkListBoxRow* row2,
                                                                  gpointer self)
{
	gint result;
	result = gitg_repository_list_box_compare_widgets ((GitgRepositoryListBox*) self, row1, row2);
#line 373 "../libgitg/gitg-repository-list-box.vala"
	return result;
#line 3924 "gitg-repository-list-box.c"
}

static GObject *
gitg_repository_list_box_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GitgRepositoryListBox * self;
	GBookmarkFile* _tmp0_;
#line 369 "../libgitg/gitg-repository-list-box.vala"
	parent_class = G_OBJECT_CLASS (gitg_repository_list_box_parent_class);
#line 369 "../libgitg/gitg-repository-list-box.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 369 "../libgitg/gitg-repository-list-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_REPOSITORY_LIST_BOX, GitgRepositoryListBox);
#line 371 "../libgitg/gitg-repository-list-box.vala"
	gtk_list_box_set_header_func ((GtkListBox*) self, _gitg_repository_list_box_update_header_gtk_list_box_update_header_func, g_object_ref (self), g_object_unref);
#line 372 "../libgitg/gitg-repository-list-box.vala"
	gtk_list_box_set_filter_func ((GtkListBox*) self, _gitg_repository_list_box_filter_gtk_list_box_filter_func, g_object_ref (self), g_object_unref);
#line 373 "../libgitg/gitg-repository-list-box.vala"
	gtk_list_box_set_sort_func ((GtkListBox*) self, _gitg_repository_list_box_compare_widgets_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 374 "../libgitg/gitg-repository-list-box.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 376 "../libgitg/gitg-repository-list-box.vala"
	gtk_list_box_set_selection_mode ((GtkListBox*) self, GTK_SELECTION_NONE);
#line 378 "../libgitg/gitg-repository-list-box.vala"
	_tmp0_ = g_bookmark_file_new ();
#line 378 "../libgitg/gitg-repository-list-box.vala"
	_g_bookmark_file_free0 (self->priv->d_bookmark_file);
#line 378 "../libgitg/gitg-repository-list-box.vala"
	self->priv->d_bookmark_file = _tmp0_;
#line 369 "../libgitg/gitg-repository-list-box.vala"
	return obj;
#line 3960 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_class_init (GitgRepositoryListBoxClass * klass,
                                     gpointer klass_data)
{
#line 28 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_parent_class = g_type_class_peek_parent (klass);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	g_type_class_adjust_private_offset (klass, &GitgRepositoryListBox_private_offset);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) gitg_repository_list_box_real_button_press_event;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	((GtkListBoxClass *) klass)->row_activated = (void (*) (GtkListBox*, GtkListBoxRow*)) gitg_repository_list_box_real_row_activated;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_repository_list_box_get_property;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_repository_list_box_set_property;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->constructor = gitg_repository_list_box_constructor;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_repository_list_box_finalize;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_MODE_PROPERTY, gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", GITG_TYPE_SELECTION_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_BOOKMARKS_FROM_RECENT_FILES_PROPERTY, gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_BOOKMARKS_FROM_RECENT_FILES_PROPERTY] = g_param_spec_boolean ("bookmarks-from-recent-files", "bookmarks-from-recent-files", "bookmarks-from-recent-files", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_LOCATION_PROPERTY, gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_LOCATION_PROPERTY] = g_param_spec_object ("location", "location", "location", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../libgitg/gitg-repository-list-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_REPOSITORY_LIST_BOX_HAS_SELECTION_PROPERTY, gitg_repository_list_box_properties[GITG_REPOSITORY_LIST_BOX_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_signals[GITG_REPOSITORY_LIST_BOX_REPOSITORY_ACTIVATED_SIGNAL] = g_signal_new ("repository-activated", GITG_TYPE_REPOSITORY_LIST_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GITG_TYPE_REPOSITORY);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	gitg_repository_list_box_signals[GITG_REPOSITORY_LIST_BOX_SHOW_ERROR_SIGNAL] = g_signal_new ("show-error", GITG_TYPE_REPOSITORY_LIST_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 3995 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_instance_init (GitgRepositoryListBox * self,
                                        gpointer klass)
{
#line 28 "../libgitg/gitg-repository-list-box.vala"
	self->priv = gitg_repository_list_box_get_instance_private (self);
#line 262 "../libgitg/gitg-repository-list-box.vala"
	self->priv->_bookmarks_from_recent_files = TRUE;
#line 4006 "gitg-repository-list-box.c"
}

static void
gitg_repository_list_box_finalize (GObject * obj)
{
	GitgRepositoryListBox * self;
#line 28 "../libgitg/gitg-repository-list-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_REPOSITORY_LIST_BOX, GitgRepositoryListBox);
#line 383 "../libgitg/gitg-repository-list-box.vala"
	if (self->priv->d_save_repository_bookmarks_id != ((guint) 0)) {
#line 385 "../libgitg/gitg-repository-list-box.vala"
		g_source_remove (self->priv->d_save_repository_bookmarks_id);
#line 386 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_save_repository_bookmarks (self);
#line 4021 "gitg-repository-list-box.c"
	}
#line 30 "../libgitg/gitg-repository-list-box.vala"
	_g_free0 (self->priv->d_filter_text);
#line 264 "../libgitg/gitg-repository-list-box.vala"
	_g_object_unref0 (self->priv->d_location);
#line 266 "../libgitg/gitg-repository-list-box.vala"
	_g_bookmark_file_free0 (self->priv->d_bookmark_file);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	G_OBJECT_CLASS (gitg_repository_list_box_parent_class)->finalize (obj);
#line 4031 "gitg-repository-list-box.c"
}

 G_GNUC_NO_INLINE static GType
gitg_repository_list_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgRepositoryListBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_repository_list_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgRepositoryListBox), 0, (GInstanceInitFunc) gitg_repository_list_box_instance_init, NULL };
	GType gitg_repository_list_box_type_id;
	gitg_repository_list_box_type_id = g_type_register_static (gtk_list_box_get_type (), "GitgRepositoryListBox", &g_define_type_info, 0);
	GitgRepositoryListBox_private_offset = g_type_add_instance_private (gitg_repository_list_box_type_id, sizeof (GitgRepositoryListBoxPrivate));
	return gitg_repository_list_box_type_id;
}

GType
gitg_repository_list_box_get_type (void)
{
	static gsize gitg_repository_list_box_type_id__once = 0;
	if (g_once_init_enter (&gitg_repository_list_box_type_id__once)) {
		GType gitg_repository_list_box_type_id;
		gitg_repository_list_box_type_id = gitg_repository_list_box_get_type_once ();
		g_once_init_leave (&gitg_repository_list_box_type_id__once, gitg_repository_list_box_type_id);
	}
	return gitg_repository_list_box_type_id__once;
}

static void
_vala_gitg_repository_list_box_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GitgRepositoryListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_REPOSITORY_LIST_BOX, GitgRepositoryListBox);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	switch (property_id) {
#line 28 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_MODE_PROPERTY:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_enum (value, gitg_repository_list_box_get_mode (self));
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 28 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_BOOKMARKS_FROM_RECENT_FILES_PROPERTY:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_boolean (value, gitg_repository_list_box_get_bookmarks_from_recent_files (self));
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 28 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_LOCATION_PROPERTY:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_object (value, gitg_repository_list_box_get_location (self));
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 28 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_HAS_SELECTION_PROPERTY:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		g_value_set_boolean (value, gitg_repository_list_box_get_has_selection (self));
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 4090 "gitg-repository-list-box.c"
		default:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 4096 "gitg-repository-list-box.c"
	}
}

static void
_vala_gitg_repository_list_box_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GitgRepositoryListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_REPOSITORY_LIST_BOX, GitgRepositoryListBox);
#line 28 "../libgitg/gitg-repository-list-box.vala"
	switch (property_id) {
#line 28 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_MODE_PROPERTY:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_set_mode (self, g_value_get_enum (value));
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 28 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_BOOKMARKS_FROM_RECENT_FILES_PROPERTY:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_set_bookmarks_from_recent_files (self, g_value_get_boolean (value));
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 28 "../libgitg/gitg-repository-list-box.vala"
		case GITG_REPOSITORY_LIST_BOX_LOCATION_PROPERTY:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		gitg_repository_list_box_set_location (self, g_value_get_object (value));
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 4128 "gitg-repository-list-box.c"
		default:
#line 28 "../libgitg/gitg-repository-list-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../libgitg/gitg-repository-list-box.vala"
		break;
#line 4134 "gitg-repository-list-box.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

